/*
 * Low-level IRQ helper macros for TI DaVinci-based platforms
 *
 * Author: Kevin Hilman, MontaVista Software, Inc. <source@mvista.com>
 *
 * 2007 (c) MontaVista Software, Inc. This file is licensed under
 * the terms of the GNU General Public License version 2. This program
 * is licensed "as is" without any warranty of any kind, whether express
 * or implied.
 */
#include <mach/io.h>
#include <mach/irqs.h>

		.macro	disable_fiq
		.endm

		.macro  get_irqnr_preamble, base, tmp
		ldr \base, =IO_ADDRESS2(AVALANCHE_INTC_BASE)
		.endm

		.macro  arch_ret_to_user, tmp1, tmp2
		.endm

#if 0
		.macro	get_irqnr_and_base, irqnr, irqstat, base, tmp
		ldr \tmp, [\base, #0x14]
		mov \tmp, \tmp, lsr #2
		sub \irqnr, \tmp, #1
		cmp \tmp, #0
		.endm
#endif

		.macro	irq_prio_table
		.endm


        .macro	get_irqnr_and_base, irqnr, irqstat, base, tmp
            mov     \base, #INTC_VIRT
            mov     r4, \base
            ldr     \irqstat, [r4, #0x280] /* Status of Int 0-31 */
            ldr     \irqnr, [r4, #0x80] /*get irq # from global priority idx reg*/
            and	\irqnr, \irqnr, #0xff     /* keep bits 0-9 */
            cmp     \irqstat, #0x0
            bne	44f
            ldr     \irqstat, [r4, #0x284] /* Status of Int 32-63*/
            cmp \irqstat, #0x0
            bne 44f
            ldr     \irqstat, [r4, #0x288] /* Status of Int 64-95*/
            cmp \irqstat, #0x0
44:
        .endm

