/*
 *
 * puma5_cppi.h
 * Description:
 * File containing CPPI configurations for each driver.
 * Put into a single file to (hopefully) avoid configuration
 * clashes.
 *
 * Copyright (C) 2008, Texas Instruments, Incorporated
 *
 *  This program is free software; you can distribute it and/or modify it
 *  under the terms of the GNU General Public License (Version 2) as
 *  published by the Free Software Foundation.
 *
 *  This program is distributed in the hope it will be useful, but WITHOUT
 *  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  59 Temple Place - Suite 330, Boston MA 02111-1307, USA.
 *
 */


#ifndef __PUMA5_CPPI_H__
#define __PUMA5_CPPI_H__

/* Global public */
#define PAL_CPPI_TOTAL_BD_NUM_INTERNAL      2048
#define PAL_CPPI_TOTAL_BD_NUM_64SIZE        4096
#define PAL_CPPI_TOTAL_BD_NUM_128SIZE          0
#define PAL_CPPI_TOTAL_BD_NUM_256SIZE          0


/* CPMAC public */
#define CPMAC_RX_EMBEDDED_BD_NUM            64
#define CPMAC_RX_HOST_BD_NUM                64
#define CPMAC_TX_HOST_BD_NUM                512
/* legacy definitions */
#define CPMAC_RX_BD_NUM                     CPMAC_RX_EMBEDDED_BD_NUM
#define CPMAC_TX_BD_NUM                     CPMAC_TX_HOST_BD_NUM                     

/* DMAC public */                                           
#define DMAC_US_BD_NUM                      32

#define DMAC_MNG_RX_HOST_BD_NUM             32
#define DMAC_MNG_TX_HOST_BD_NUM             32

/* PP-FW public */
#define PPFW_EVENT_DESC_NUM                 256

/* legacy definitions */
#define PPFW_REPLICA_DESC_COUNT             (0)
#define PPFW_PREFETCH_DESC_COUNT            (510)

#define PPFW_PREFETCH_BUFF_COUNT            (24)

#include "puma5_cppi_prv.h"
#include <asm/cacheflush.h>

#define PAL_CPPI4_CACHE_INVALIDATE(addr, size)              dma_cache_inv ((unsigned long)(addr), (size))
#define PAL_CPPI4_CACHE_WRITEBACK(addr, size)               dma_cache_wback ((unsigned long)(addr), (size))
#define PAL_CPPI4_CACHE_WRITEBACK_INVALIDATE(addr, size)    dma_cache_wback_inv ((unsigned long)(addr), (size))

// #define dmac_inv_range			cpu_cache.dma_inv_range
// #define dmac_clean_range		cpu_cache.dma_clean_range
// #define dmac_flush_range		cpu_cache.dma_flush_range

#endif /* __PUMA5_CPPI_H__ */ 
