/******************************************************************************
**
** FILE NAME    : ifxmips_pmu_danube.h
** PROJECT      : IFX UEIP
** MODULES      : PMU
**
** DATE         : 02 Sep 2009
** AUTHOR       : Lei Chuanhua
** DESCRIPTION  : IFX PMU danube specific header file
** COPYRIGHT    :       Copyright (c) 2009
**                      Infineon Technologies AG
**                      Am Campeon 1-12, 85579 Neubiberg, Germany
**
**    This program is free software; you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation; either version 2 of the License, or
**    (at your option) any later version.
**
** HISTORY
** $Date        $Author         $Comment
** 02 Sep 2009  Lei Chuanhua    The first UEIP release
*******************************************************************************/
/*!
  \file ifxmips_pmu_danube.h
  \ingroup IFX_PMU
  \brief PMU driver DANUBE specific file
*/

#ifndef IFXMIPS_PMU_DANUBE_H
#define IFXMIPS_PMU_DANUBE_H

#define IFX_PMU_MODULE_ID_IDX_MIN  IFX_PMU_MODULE_USB_PHY
#define IFX_PMU_MODULE_ID_IDX_MAX  IFX_PMU_MODULE_TDM

static ifx_pmu_t g_ifx_pmu = {
    .pmu_pwdcr[0]  = IFX_PMU_PWDCR,
    .pmu_pwdcr[1]  = NULL,
    .pmu_sr[0]     = IFX_PMU_SR,
    .pmu_sr[1]     = NULL,
    .module        = {
                    {0, "USB-PHY",  1},
                    {0, "FPI1",     0},
                    {0, "VO-MIPS",  1},
                    {0, "VODEC",    1},
                    {0, "PCI",      0},
                    {0, "DMA",      1}, /* Default is off, has to be controlled */
                    {0, "USB-CTRL", 1},
                    {0, "UART0",    1},
                    {0, "SPI",      1},
                    {0, "DSL-DFE",  1},
                    {0, "EBU",      0},
                    {0, "LEDC",     1},
                    {0, "GPTC",     1},
                    {0, "PPE",      1},
                    {0, "FPI0",     0},
                    {0, "AHB",      1},
                    {0, "SDIO",     1},
                    {0, "UART1",    0}, /* Keep console on */  
                    {0, "WDT0",     1},
                    {0, "WDT1",     1},
                    {0, "DEU",      1},
                    {0, "PPE-TC",   1},
                    {0, "PPE-ENET1",1},
                    {0, "PPE-ENET0",1},
                    {0, "",         0},
                    {0, "TDM",      1},
                    {0, "",         0},
                    {0, "",         0},
                    {0, "",         0},
                    {0, "",         0},
                    {0, "",         0},
                    {0, "",         0},
                    {0, "",         0},
                    {0, "",         0},
                    {0, "",         0},
                    {0, "",         0},
                    {0, "",         0},
                    {0, "",         0},
                    {0, "",         0},
                    {0, "",         0},
                    },
};
#endif /* IFXMIPS_PMU_DANUBE_H */

