/******************************************************************************

                              Copyright (c) 2010
                            Lantiq Deutschland GmbH
                     Am Campeon 3; 85579 Neubiberg, Germany

  For licensing information, see the file 'LICENSE' in the root folder of
  this software module.

******************************************************************************/
#ifndef _IFX_ETHSW_REGMAPPERSELECTOR_H
#define _IFX_ETHSW_REGMAPPERSELECTOR_H

typedef enum {
   ARP_APT, /* (# 0) */
   ARP_MACA, /* (# 1) */
   ARP_RAPA, /* (# 2) */
   ARP_RAPOTH, /* (# 3) */
   ARP_RAPP, /* (# 4) */
   ARP_RAPPE, /* (# 5) */
   ARP_RAPTM, /* (# 6) */
   ARP_RPT, /* (# 7) */
   ARP_TAP, /* (# 8) */
   ARP_TAPTS, /* (# 9) */
   ARP_TRP, /* (# 10) */
   ARP_UPT, /* (# 11) */
   BIST_CTBR, /* (# 12) */
   BIST_DBBR, /* (# 13) */
   BIST_DONE, /* (# 14) */
   BIST_HIGTBR, /* (# 15) */
   BIST_HISTBR, /* (# 16) */
   BIST_LLTBR, /* (# 17) */
   BIST_LTBR, /* (# 18) */
   BUFFER_PFA, /* (# 19) */
   BUFFER_PFO0, /* (# 20) */
   BUFFER_PFO1, /* (# 21) */
   BUFFER_PFO2, /* (# 22) */
   BUFFER_PUA, /* (# 23) */
   BUFFER_PUO0, /* (# 24) */
   BUFFER_PUO1, /* (# 25) */
   BUFFER_PUO2, /* (# 26) */
   BUFFER_THA, /* (# 27) */
   BUFFER_THO, /* (# 28) */
   BUFFER_TLA, /* (# 29) */
   BUFFER_TLO, /* (# 30) */
   CHIPID_BOND, /* (# 31) */
   CHIPID_PC, /* (# 32) */
   CHIPID_VN, /* (# 33) */
   CONGESTION_EDSTX, /* (# 34) */
   CONGESTION_IJT, /* (# 35) */
   CONGESTION_IRSJA, /* (# 36) */
   CONGESTION_STORM_100_TH, /* (# 37) */
   CONGESTION_STORM_10_TH, /* (# 38) */
   CONGESTION_STORM_B, /* (# 39) */
   CONGESTION_STORM_M, /* (# 40) */
   CONGESTION_STORM_U, /* (# 41) */
   DIFFSERV_PQA, /* (# 42) */
   DIFFSERV_PQA01, /* (# 43) */
   DIFFSERV_PQA02, /* (# 44) */
   DIFFSERV_PQA03, /* (# 45) */
   DIFFSERV_PQA04, /* (# 46) */
   DIFFSERV_PQA05, /* (# 47) */
   DIFFSERV_PQA06, /* (# 48) */
   DIFFSERV_PQA07, /* (# 49) */
   DIFFSERV_PQA08, /* (# 50) */
   DIFFSERV_PQA09, /* (# 51) */
   DIFFSERV_PQA10, /* (# 52) */
   DIFFSERV_PQA11, /* (# 53) */
   DIFFSERV_PQA12, /* (# 54) */
   DIFFSERV_PQA13, /* (# 55) */
   DIFFSERV_PQA14, /* (# 56) */
   DIFFSERV_PQA15, /* (# 57) */
   DIFFSERV_PQB, /* (# 58) */
   DIFFSERV_PQB01, /* (# 59) */
   DIFFSERV_PQB02, /* (# 60) */
   DIFFSERV_PQB03, /* (# 61) */
   DIFFSERV_PQB04, /* (# 62) */
   DIFFSERV_PQB05, /* (# 63) */
   DIFFSERV_PQB06, /* (# 64) */
   DIFFSERV_PQB07, /* (# 65) */
   DIFFSERV_PQB08, /* (# 66) */
   DIFFSERV_PQB09, /* (# 67) */
   DIFFSERV_PQB10, /* (# 68) */
   DIFFSERV_PQB11, /* (# 69) */
   DIFFSERV_PQB12, /* (# 70) */
   DIFFSERV_PQB13, /* (# 71) */
   DIFFSERV_PQB14, /* (# 72) */
   DIFFSERV_PQB15, /* (# 73) */
   DIFFSERV_PQC, /* (# 74) */
   DIFFSERV_PQC01, /* (# 75) */
   DIFFSERV_PQC02, /* (# 76) */
   DIFFSERV_PQC03, /* (# 77) */
   DIFFSERV_PQC04, /* (# 78) */
   DIFFSERV_PQC05, /* (# 79) */
   DIFFSERV_PQC06, /* (# 80) */
   DIFFSERV_PQC07, /* (# 81) */
   DIFFSERV_PQC08, /* (# 82) */
   DIFFSERV_PQC09, /* (# 83) */
   DIFFSERV_PQC10, /* (# 84) */
   DIFFSERV_PQC11, /* (# 85) */
   DIFFSERV_PQC12, /* (# 86) */
   DIFFSERV_PQC13, /* (# 87) */
   DIFFSERV_PQC14, /* (# 88) */
   DIFFSERV_PQC15, /* (# 89) */
   DIFFSERV_PQD, /* (# 90) */
   DIFFSERV_PQD01, /* (# 91) */
   DIFFSERV_PQD02, /* (# 92) */
   DIFFSERV_PQD03, /* (# 93) */
   DIFFSERV_PQD04, /* (# 94) */
   DIFFSERV_PQD05, /* (# 95) */
   DIFFSERV_PQD06, /* (# 96) */
   DIFFSERV_PQD07, /* (# 97) */
   DIFFSERV_PQD08, /* (# 98) */
   DIFFSERV_PQD09, /* (# 99) */
   DIFFSERV_PQD10, /* (# 100) */
   DIFFSERV_PQD11, /* (# 101) */
   DIFFSERV_PQD12, /* (# 102) */
   DIFFSERV_PQD13, /* (# 103) */
   DIFFSERV_PQD14, /* (# 104) */
   DIFFSERV_PQD15, /* (# 105) */
   DOT1X_PRIORITY_1PPQ, /* (# 106) */
   DOT1X_PRIORITY_1PPQ1, /* (# 107) */
   DOT1X_PRIORITY_1PPQ2, /* (# 108) */
   DOT1X_PRIORITY_1PPQ3, /* (# 109) */
   DOT1X_PRIORITY_1PPQ4, /* (# 110) */
   DOT1X_PRIORITY_1PPQ5, /* (# 111) */
   DOT1X_PRIORITY_1PPQ6, /* (# 112) */
   DOT1X_PRIORITY_1PPQ7, /* (# 113) */
   GLOBAL_ATS, /* (# 114) */
   GLOBAL_CTTX, /* (# 115) */
   GLOBAL_DIE, /* (# 116) */
   GLOBAL_DII6P, /* (# 117) */
   GLOBAL_DIIP, /* (# 118) */
   GLOBAL_DIIPS, /* (# 119) */
   GLOBAL_DIS, /* (# 120) */
   GLOBAL_DIVS, /* (# 121) */
   GLOBAL_DMQ0, /* (# 122) */
   GLOBAL_DMQ1, /* (# 123) */
   GLOBAL_DMQ2, /* (# 124) */
   GLOBAL_DMQ3, /* (# 125) */
   GLOBAL_DPWECH, /* (# 126) */
   GLOBAL_DUPCOLSP, /* (# 127) */
   GLOBAL_ICRCCD, /* (# 128) */
   GLOBAL_ITENLMT, /* (# 129) */
   GLOBAL_ITRUNK, /* (# 130) */
   GLOBAL_LPE, /* (# 131) */
   GLOBAL_MPL, /* (# 132) */
   GLOBAL_P4M, /* (# 133) */
   GLOBAL_P5M, /* (# 134) */
   GLOBAL_P6M, /* (# 135) */
   GLOBAL_PCE, /* (# 136) */
   GLOBAL_PCR, /* (# 137) */
   GLOBAL_PHYBA, /* (# 138) */
   GLOBAL_RVID0, /* (# 139) */
   GLOBAL_RVID1, /* (# 140) */
   GLOBAL_RVIDFFF, /* (# 141) */
   GLOBAL_SE, /* (# 142) */
   GLOBAL_TSIPGE, /* (# 143) */
   INGRESS_FLOW_CTRL_B, /* (# 144) */
   INGRESS_FLOW_CTRL_BASE15_0, /* (# 145) */
   INGRESS_FLOW_CTRL_BASE17_16, /* (# 146) */
   INGRESS_FLOW_CTRL_EBASE15_0, /* (# 147) */
   INGRESS_FLOW_CTRL_EBASE17_16, /* (# 148) */
   INGRESS_FLOW_CTRL_F, /* (# 149) */
   IRQ_DBF, /* (# 150) */
   IRQ_DBFIE, /* (# 151) */
   IRQ_DBNF, /* (# 152) */
   IRQ_DBNFIE, /* (# 153) */
   IRQ_LTAD, /* (# 154) */
   IRQ_LTADIE, /* (# 155) */
   IRQ_LTF, /* (# 156) */
   IRQ_LTFIE, /* (# 157) */
   IRQ_PSC, /* (# 158) */
   IRQ_PSCIE, /* (# 159) */
   IRQ_PSV, /* (# 160) */
   IRQ_PSVIE, /* (# 161) */
   MAC_TABLE_ADDR15_0, /* (# 162) */
   MAC_TABLE_ADDR31_0, /* (# 163) */
   MAC_TABLE_ADDR31_16, /* (# 164) */
   MAC_TABLE_ADDR47_32, /* (# 165) */
   MAC_TABLE_ADDRS15_0, /* (# 166) */
   MAC_TABLE_ADDRS31_0, /* (# 167) */
   MAC_TABLE_ADDRS31_16, /* (# 168) */
   MAC_TABLE_ADDRS47_32, /* (# 169) */
   MAC_TABLE_BAD, /* (# 170) */
   MAC_TABLE_BUSY, /* (# 171) */
   MAC_TABLE_C_AC, /* (# 172) */
   MAC_TABLE_C_CMD, /* (# 173) */
   MAC_TABLE_C_FCE, /* (# 174) */
   MAC_TABLE_FID, /* (# 175) */
   MAC_TABLE_FIDS, /* (# 176) */
   MAC_TABLE_INFOT, /* (# 177) */
   MAC_TABLE_INFOTS, /* (# 178) */
   MAC_TABLE_ITAT, /* (# 179) */
   MAC_TABLE_ITATS, /* (# 180) */
   MAC_TABLE_OCP, /* (# 181) */
   MAC_TABLE_PMAP, /* (# 182) */
   MAC_TABLE_PMAPS, /* (# 183) */
   MAC_TABLE_RSLT, /* (# 184) */
   MAC_TABLE_S_AC, /* (# 185) */
   MAC_TABLE_S_CMD, /* (# 186) */
   MAC_TABLE_S_FCE, /* (# 187) */
   MCS, /* (# 188) */
   MDIO_MBUSY, /* (# 189) */
   MDIO_OP, /* (# 190) */
   MDIO_PHYAD, /* (# 191) */
   MDIO_RD, /* (# 192) */
   MDIO_REGAD, /* (# 193) */
   MDIO_WD, /* (# 194) */
   MIRROR_CCCRC, /* (# 195) */
   MIRROR_CPN, /* (# 196) */
   MIRROR_IGSTA, /* (# 197) */
   MIRROR_MCA, /* (# 198) */
   MIRROR_MLA, /* (# 199) */
   MIRROR_MPA, /* (# 200) */
   MIRROR_MRA, /* (# 201) */
   MIRROR_MSA, /* (# 202) */
   MIRROR_PAST, /* (# 203) */
   MIRROR_SNIFFPN, /* (# 204) */
   MIRROR_STRE, /* (# 205) */
   MIRROR_STTE, /* (# 206) */
   MULTICAST_ASC, /* (# 207) */
   MULTICAST_B01, /* (# 208) */
   MULTICAST_B224, /* (# 209) */
   MULTICAST_B33, /* (# 210) */
   MULTICAST_DAIPS, /* (# 211) */
   MULTICAST_DRP, /* (# 212) */
   MULTICAST_FMODE, /* (# 213) */
   MULTICAST_GID15_0, /* (# 214) */
   MULTICAST_GID31_16, /* (# 215) */
   MULTICAST_HIPI, /* (# 216) */
   MULTICAST_HISE, /* (# 217) */
   MULTICAST_HISFL, /* (# 218) */
   MULTICAST_ICMD, /* (# 219) */
   MULTICAST_IGMPV3E, /* (# 220) */
   MULTICAST_INVC, /* (# 221) */
   MULTICAST_IPMPT, /* (# 222) */
   MULTICAST_PORT, /* (# 223) */
   MULTICAST_PPPOEHR, /* (# 224) */
   MULTICAST_QI, /* (# 225) */
   MULTICAST_RV, /* (# 226) */
   MULTICAST_S3PMI, /* (# 227) */
   MULTICAST_S3PMV, /* (# 228) */
   MULTICAST_S4BUSY, /* (# 229) */
   MULTICAST_S4R, /* (# 230) */
   MULTICAST_SARE, /* (# 231) */
   MULTICAST_SCPA, /* (# 232) */
   MULTICAST_SCPP, /* (# 233) */
   MULTICAST_SCPPE, /* (# 234) */
   MULTICAST_SCPTCP, /* (# 235) */
   MULTICAST_SCPTMP, /* (# 236) */
   MULTICAST_SCPTSP, /* (# 237) */
   MULTICAST_SCPTTH, /* (# 238) */
   MULTICAST_SIP15_0, /* (# 239) */
   MULTICAST_SIP31_16, /* (# 240) */
   MULTICAST_SIP47_32, /* (# 241) */
   MULTICAST_SIPGID0, /* (# 242) */
   MULTICAST_SIPGID1, /* (# 243) */
   MULTICAST_SIPGID2, /* (# 244) */
   MULTICAST_TIMERC, /* (# 245) */
   PAUSE_ADDR15_0, /* (# 246) */
   PAUSE_ADDR31_16, /* (# 247) */
   PAUSE_ADDR39_32, /* (# 248) */
   PAUSE_ADDR47_41, /* (# 249) */
   PAUSE_PAC, /* (# 250) */
   PHY_INIT_PHYIE0, /* (# 251) */
   PHY_INIT_PHYIE01, /* (# 252) */
   PHY_INIT_PHYIE02, /* (# 253) */
   PHY_INIT_PHYIE03, /* (# 254) */
   PHY_INIT_PHYIE1, /* (# 255) */
   PHY_INIT_PHYIE11, /* (# 256) */
   PHY_INIT_PHYIE12, /* (# 257) */
   PHY_INIT_PHYIE13, /* (# 258) */
   PHY_INIT_PHYIE2, /* (# 259) */
   PHY_INIT_PHYIE21, /* (# 260) */
   PHY_INIT_PHYIE22, /* (# 261) */
   PHY_INIT_PHYIE23, /* (# 262) */
   PHY_INIT_PHYIE3, /* (# 263) */
   PHY_INIT_PHYIE31, /* (# 264) */
   PHY_INIT_PHYIE32, /* (# 265) */
   PHY_INIT_PHYIE33, /* (# 266) */
   PHY_INIT_PHYIE4, /* (# 267) */
   PHY_INIT_PHYIE41, /* (# 268) */
   PHY_INIT_PHYIE42, /* (# 269) */
   PHY_INIT_PHYIE43, /* (# 270) */
   PHY_INIT_PHYIE5, /* (# 271) */
   PHY_INIT_PHYIE51, /* (# 272) */
   PHY_INIT_PHYIE52, /* (# 273) */
   PHY_INIT_PHYIE53, /* (# 274) */
   PHY_INIT_PHYIE6, /* (# 275) */
   PHY_INIT_PHYIE61, /* (# 276) */
   PHY_INIT_PHYIE62, /* (# 277) */
   PHY_INIT_PHYIE63, /* (# 278) */
   PHY_INIT_REGA, /* (# 279) */
   PHY_INIT_REGA1, /* (# 280) */
   PHY_INIT_REGA2, /* (# 281) */
   PHY_INIT_REGA3, /* (# 282) */
   PHY_INIT_REGD, /* (# 283) */
   PHY_INIT_REGD1, /* (# 284) */
   PHY_INIT_REGD2, /* (# 285) */
   PHY_INIT_REGD3, /* (# 286) */
   PMAC_ADD, /* (# 287) */
   PMAC_ADD_CRC, /* (# 288) */
   PMAC_AS, /* (# 289) */
   PMAC_CFI, /* (# 290) */
   PMAC_DA_31_0, /* (# 291) */
   PMAC_DA_47_32, /* (# 292) */
   PMAC_IDIS_REQ_WM, /* (# 293) */
   PMAC_IPG_RX_CNT, /* (# 294) */
   PMAC_IPG_TX_CNT, /* (# 295) */
   PMAC_IREQ_WM, /* (# 296) */
   PMAC_PRI, /* (# 297) */
   PMAC_RC, /* (# 298) */
   PMAC_RL2, /* (# 299) */
   PMAC_RXSH, /* (# 300) */
   PMAC_SA_31_0, /* (# 301) */
   PMAC_SA_47_32, /* (# 302) */
   PMAC_TAG, /* (# 303) */
   PMAC_TYPE_LEN, /* (# 304) */
   PMAC_VLAN_ID, /* (# 305) */
   PORT_AD, /* (# 306) */
   PORT_AD1, /* (# 307) */
   PORT_AD2, /* (# 308) */
   PORT_AD3, /* (# 309) */
   PORT_AD4, /* (# 310) */
   PORT_AD5, /* (# 311) */
   PORT_AD6, /* (# 312) */
   PORT_BP, /* (# 313) */
   PORT_DFWD, /* (# 314) */
   PORT_DFWD1, /* (# 315) */
   PORT_DFWD2, /* (# 316) */
   PORT_DSV821X, /* (# 317) */
   PORT_DSV821X1, /* (# 318) */
   PORT_DSV821X2, /* (# 319) */
   PORT_EGRESS_PSPQ0TR, /* (# 320) */
   PORT_EGRESS_PSPQ0TR1, /* (# 321) */
   PORT_EGRESS_PSPQ0TR2, /* (# 322) */
   PORT_EGRESS_PSPQ0TR3, /* (# 323) */
   PORT_EGRESS_PSPQ0TR4, /* (# 324) */
   PORT_EGRESS_PSPQ0TR5, /* (# 325) */
   PORT_EGRESS_PSPQ0TR6, /* (# 326) */
   PORT_EGRESS_PSPQ1TR, /* (# 327) */
   PORT_EGRESS_PSPQ1TR1, /* (# 328) */
   PORT_EGRESS_PSPQ1TR2, /* (# 329) */
   PORT_EGRESS_PSPQ1TR3, /* (# 330) */
   PORT_EGRESS_PSPQ1TR4, /* (# 331) */
   PORT_EGRESS_PSPQ1TR5, /* (# 332) */
   PORT_EGRESS_PSPQ1TR6, /* (# 333) */
   PORT_EGRESS_PSPQ2TR, /* (# 334) */
   PORT_EGRESS_PSPQ2TR1, /* (# 335) */
   PORT_EGRESS_PSPQ2TR2, /* (# 336) */
   PORT_EGRESS_PSPQ2TR3, /* (# 337) */
   PORT_EGRESS_PSPQ2TR4, /* (# 338) */
   PORT_EGRESS_PSPQ2TR5, /* (# 339) */
   PORT_EGRESS_PSPQ2TR6, /* (# 340) */
   PORT_EGRESS_PSPQ3TR, /* (# 341) */
   PORT_EGRESS_PSPQ3TR1, /* (# 342) */
   PORT_EGRESS_PSPQ3TR2, /* (# 343) */
   PORT_EGRESS_PSPQ3TR3, /* (# 344) */
   PORT_EGRESS_PSPQ3TR4, /* (# 345) */
   PORT_EGRESS_PSPQ3TR5, /* (# 346) */
   PORT_EGRESS_PSPQ3TR6, /* (# 347) */
   PORT_EGRESS_PWQ0TR, /* (# 348) */
   PORT_EGRESS_PWQ0TR1, /* (# 349) */
   PORT_EGRESS_PWQ0TR2, /* (# 350) */
   PORT_EGRESS_PWQ0TR3, /* (# 351) */
   PORT_EGRESS_PWQ0TR4, /* (# 352) */
   PORT_EGRESS_PWQ0TR5, /* (# 353) */
   PORT_EGRESS_PWQ0TR6, /* (# 354) */
   PORT_EGRESS_PWQ1TR, /* (# 355) */
   PORT_EGRESS_PWQ1TR1, /* (# 356) */
   PORT_EGRESS_PWQ1TR2, /* (# 357) */
   PORT_EGRESS_PWQ1TR3, /* (# 358) */
   PORT_EGRESS_PWQ1TR4, /* (# 359) */
   PORT_EGRESS_PWQ1TR5, /* (# 360) */
   PORT_EGRESS_PWQ1TR6, /* (# 361) */
   PORT_EGRESS_PWQ2TR, /* (# 362) */
   PORT_EGRESS_PWQ2TR1, /* (# 363) */
   PORT_EGRESS_PWQ2TR2, /* (# 364) */
   PORT_EGRESS_PWQ2TR3, /* (# 365) */
   PORT_EGRESS_PWQ2TR4, /* (# 366) */
   PORT_EGRESS_PWQ2TR5, /* (# 367) */
   PORT_EGRESS_PWQ2TR6, /* (# 368) */
   PORT_EGRESS_PWQ3TR, /* (# 369) */
   PORT_EGRESS_PWQ3TR1, /* (# 370) */
   PORT_EGRESS_PWQ3TR2, /* (# 371) */
   PORT_EGRESS_PWQ3TR3, /* (# 372) */
   PORT_EGRESS_PWQ3TR4, /* (# 373) */
   PORT_EGRESS_PWQ3TR5, /* (# 374) */
   PORT_EGRESS_PWQ3TR6, /* (# 375) */
   PORT_FILTER_ATUF, /* (# 376) */
   PORT_FILTER_ATUF1, /* (# 377) */
   PORT_FILTER_ATUF2, /* (# 378) */
   PORT_FILTER_ATUF3, /* (# 379) */
   PORT_FILTER_ATUF4, /* (# 380) */
   PORT_FILTER_ATUF5, /* (# 381) */
   PORT_FILTER_ATUF6, /* (# 382) */
   PORT_FILTER_ATUF7, /* (# 383) */
   PORT_FILTER_BASEPT, /* (# 384) */
   PORT_FILTER_BASEPT1, /* (# 385) */
   PORT_FILTER_BASEPT2, /* (# 386) */
   PORT_FILTER_BASEPT3, /* (# 387) */
   PORT_FILTER_BASEPT4, /* (# 388) */
   PORT_FILTER_BASEPT5, /* (# 389) */
   PORT_FILTER_BASEPT6, /* (# 390) */
   PORT_FILTER_BASEPT7, /* (# 391) */
   PORT_FILTER_COMP, /* (# 392) */
   PORT_FILTER_COMP1, /* (# 393) */
   PORT_FILTER_COMP2, /* (# 394) */
   PORT_FILTER_COMP3, /* (# 395) */
   PORT_FILTER_COMP4, /* (# 396) */
   PORT_FILTER_COMP5, /* (# 397) */
   PORT_FILTER_COMP6, /* (# 398) */
   PORT_FILTER_COMP7, /* (# 399) */
   PORT_FILTER_PRANGE, /* (# 400) */
   PORT_FILTER_PRANGE1, /* (# 401) */
   PORT_FILTER_PRANGE2, /* (# 402) */
   PORT_FILTER_PRANGE3, /* (# 403) */
   PORT_FILTER_PRANGE4, /* (# 404) */
   PORT_FILTER_PRANGE5, /* (# 405) */
   PORT_FILTER_PRANGE6, /* (# 406) */
   PORT_FILTER_PRANGE7, /* (# 407) */
   PORT_FILTER_TUPF, /* (# 408) */
   PORT_FILTER_TUPF1, /* (# 409) */
   PORT_FILTER_TUPF2, /* (# 410) */
   PORT_FILTER_TUPF3, /* (# 411) */
   PORT_FILTER_TUPF4, /* (# 412) */
   PORT_FILTER_TUPF5, /* (# 413) */
   PORT_FILTER_TUPF6, /* (# 414) */
   PORT_FILTER_TUPF7, /* (# 415) */
   PORT_FLD, /* (# 416) */
   PORT_FLD1, /* (# 417) */
   PORT_FLD2, /* (# 418) */
   PORT_FLD3, /* (# 419) */
   PORT_FLD4, /* (# 420) */
   PORT_FLD5, /* (# 421) */
   PORT_FLD6, /* (# 422) */
   PORT_FLP, /* (# 423) */
   PORT_FLP1, /* (# 424) */
   PORT_FLP2, /* (# 425) */
   PORT_FLP3, /* (# 426) */
   PORT_FLP4, /* (# 427) */
   PORT_FLP5, /* (# 428) */
   PORT_FLP6, /* (# 429) */
   PORT_IFNTE, /* (# 430) */
   PORT_IFNTE1, /* (# 431) */
   PORT_IFNTE2, /* (# 432) */
   PORT_IFNTE3, /* (# 433) */
   PORT_IFNTE4, /* (# 434) */
   PORT_IFNTE5, /* (# 435) */
   PORT_IFNTE6, /* (# 436) */
   PORT_IMTE, /* (# 437) */
   PORT_IMTE1, /* (# 438) */
   PORT_IMTE2, /* (# 439) */
   PORT_IMTE3, /* (# 440) */
   PORT_IMTE4, /* (# 441) */
   PORT_IMTE5, /* (# 442) */
   PORT_IMTE6, /* (# 443) */
   PORT_INGRESS_PITR, /* (# 444) */
   PORT_INGRESS_PITR1, /* (# 445) */
   PORT_INGRESS_PITR2, /* (# 446) */
   PORT_INGRESS_PITR3, /* (# 447) */
   PORT_INGRESS_PITR4, /* (# 448) */
   PORT_INGRESS_PITR5, /* (# 449) */
   PORT_INGRESS_PITR6, /* (# 450) */
   PORT_INGRESS_PITT, /* (# 451) */
   PORT_INGRESS_PITT1, /* (# 452) */
   PORT_INGRESS_PITT2, /* (# 453) */
   PORT_INGRESS_PITT3, /* (# 454) */
   PORT_INGRESS_PITT4, /* (# 455) */
   PORT_INGRESS_PITT5, /* (# 456) */
   PORT_INGRESS_PITT6, /* (# 457) */
   PORT_IPMO, /* (# 458) */
   PORT_IPMO1, /* (# 459) */
   PORT_IPMO2, /* (# 460) */
   PORT_IPMO3, /* (# 461) */
   PORT_IPMO4, /* (# 462) */
   PORT_IPMO5, /* (# 463) */
   PORT_IPMO6, /* (# 464) */
   PORT_IPOVTU, /* (# 465) */
   PORT_IPOVTU1, /* (# 466) */
   PORT_IPOVTU2, /* (# 467) */
   PORT_IPOVTU3, /* (# 468) */
   PORT_IPOVTU4, /* (# 469) */
   PORT_IPOVTU5, /* (# 470) */
   PORT_IPOVTU6, /* (# 471) */
   PORT_IPVLAN, /* (# 472) */
   PORT_IPVLAN1, /* (# 473) */
   PORT_IPVLAN2, /* (# 474) */
   PORT_IPVLAN3, /* (# 475) */
   PORT_IPVLAN4, /* (# 476) */
   PORT_IPVLAN5, /* (# 477) */
   PORT_IPVLAN6, /* (# 478) */
   PORT_LD, /* (# 479) */
   PORT_LD1, /* (# 480) */
   PORT_LD2, /* (# 481) */
   PORT_LD3, /* (# 482) */
   PORT_LD4, /* (# 483) */
   PORT_LD5, /* (# 484) */
   PORT_LD6, /* (# 485) */
   PORT_MNA24, /* (# 486) */
   PORT_MNA241, /* (# 487) */
   PORT_MNA242, /* (# 488) */
   PORT_MNA243, /* (# 489) */
   PORT_MNA244, /* (# 490) */
   PORT_MNA245, /* (# 491) */
   PORT_MNA246, /* (# 492) */
   PORT_MP, /* (# 493) */
   PORT_PAS, /* (# 494) */
   PORT_PAS1, /* (# 495) */
   PORT_PAS2, /* (# 496) */
   PORT_PAS3, /* (# 497) */
   PORT_PAS4, /* (# 498) */
   PORT_PAS5, /* (# 499) */
   PORT_PAS6, /* (# 500) */
   PORT_PDS, /* (# 501) */
   PORT_PDS1, /* (# 502) */
   PORT_PDS2, /* (# 503) */
   PORT_PDS3, /* (# 504) */
   PORT_PDS4, /* (# 505) */
   PORT_PDS5, /* (# 506) */
   PORT_PDS6, /* (# 507) */
   PORT_PFCS, /* (# 508) */
   PORT_PFCS1, /* (# 509) */
   PORT_PFCS2, /* (# 510) */
   PORT_PFCS3, /* (# 511) */
   PORT_PFCS4, /* (# 512) */
   PORT_PFCS5, /* (# 513) */
   PORT_PFCS6, /* (# 514) */
   PORT_PLS, /* (# 515) */
   PORT_PLS1, /* (# 516) */
   PORT_PLS2, /* (# 517) */
   PORT_PLS3, /* (# 518) */
   PORT_PLS4, /* (# 519) */
   PORT_PLS5, /* (# 520) */
   PORT_PLS6, /* (# 521) */
   PORT_PM, /* (# 522) */
   PORT_PM1, /* (# 523) */
   PORT_PM2, /* (# 524) */
   PORT_PM3, /* (# 525) */
   PORT_PM4, /* (# 526) */
   PORT_PM5, /* (# 527) */
   PORT_PM6, /* (# 528) */
   PORT_PPPOEP, /* (# 529) */
   PORT_PPPOEP1, /* (# 530) */
   PORT_PPPOEP2, /* (# 531) */
   PORT_PPPOEP3, /* (# 532) */
   PORT_PPPOEP4, /* (# 533) */
   PORT_PPPOEP5, /* (# 534) */
   PORT_PPPOEP6, /* (# 535) */
   PORT_PSHS, /* (# 536) */
   PORT_PSHS1, /* (# 537) */
   PORT_PSHS2, /* (# 538) */
   PORT_PSHS3, /* (# 539) */
   PORT_PSHS4, /* (# 540) */
   PORT_PSHS5, /* (# 541) */
   PORT_PSHS6, /* (# 542) */
   PORT_PSS, /* (# 543) */
   PORT_PSS1, /* (# 544) */
   PORT_PSS2, /* (# 545) */
   PORT_PSS3, /* (# 546) */
   PORT_PSS4, /* (# 547) */
   PORT_PSS5, /* (# 548) */
   PORT_PSS6, /* (# 549) */
   PORT_REDIR, /* (# 550) */
   PORT_REDIR1, /* (# 551) */
   PORT_REDIR2, /* (# 552) */
   PORT_RGMII_GMII_P0CKIO, /* (# 553) */
   PORT_RGMII_GMII_P0DUP, /* (# 554) */
   PORT_RGMII_GMII_P0FCE, /* (# 555) */
   PORT_RGMII_GMII_P0FEQ, /* (# 556) */
   PORT_RGMII_GMII_P0IS, /* (# 557) */
   PORT_RGMII_GMII_P0RDLY, /* (# 558) */
   PORT_RGMII_GMII_P0SPD, /* (# 559) */
   PORT_RGMII_GMII_P0TDLY, /* (# 560) */
   PORT_RGMII_GMII_P1CKIO, /* (# 561) */
   PORT_RGMII_GMII_P1DUP, /* (# 562) */
   PORT_RGMII_GMII_P1FCE, /* (# 563) */
   PORT_RGMII_GMII_P1FEQ, /* (# 564) */
   PORT_RGMII_GMII_P1IS, /* (# 565) */
   PORT_RGMII_GMII_P1RDLY, /* (# 566) */
   PORT_RGMII_GMII_P1SPD, /* (# 567) */
   PORT_RGMII_GMII_P1TDLY, /* (# 568) */
   PORT_RGMII_GMII_P4DUP, /* (# 569) */
   PORT_RGMII_GMII_P4FCE, /* (# 570) */
   PORT_RGMII_GMII_P4SPD, /* (# 571) */
   PORT_RGMII_GMII_P5DUP, /* (# 572) */
   PORT_RGMII_GMII_P5FCE, /* (# 573) */
   PORT_RGMII_GMII_P5SPD, /* (# 574) */
   PORT_RGMII_GMII_P6DUP, /* (# 575) */
   PORT_RGMII_GMII_P6FCE, /* (# 576) */
   PORT_RGMII_GMII_P6SPD, /* (# 577) */
   PORT_RMWFQ, /* (# 578) */
   PORT_RMWFQ1, /* (# 579) */
   PORT_RMWFQ2, /* (# 580) */
   PORT_RMWFQ3, /* (# 581) */
   PORT_RMWFQ4, /* (# 582) */
   PORT_RMWFQ5, /* (# 583) */
   PORT_RMWFQ6, /* (# 584) */
   PORT_RP, /* (# 585) */
   PORT_SPE, /* (# 586) */
   PORT_SPE1, /* (# 587) */
   PORT_SPE2, /* (# 588) */
   PORT_SPE3, /* (# 589) */
   PORT_SPE4, /* (# 590) */
   PORT_SPE5, /* (# 591) */
   PORT_SPE6, /* (# 592) */
   PORT_SPS, /* (# 593) */
   PORT_SPS1, /* (# 594) */
   PORT_SPS2, /* (# 595) */
   PORT_SPS3, /* (# 596) */
   PORT_SPS4, /* (# 597) */
   PORT_SPS5, /* (# 598) */
   PORT_SPS6, /* (# 599) */
   PORT_TCPE, /* (# 600) */
   PORT_TCPE1, /* (# 601) */
   PORT_TCPE2, /* (# 602) */
   PORT_TCPE3, /* (# 603) */
   PORT_TCPE4, /* (# 604) */
   PORT_TCPE5, /* (# 605) */
   PORT_TCPE6, /* (# 606) */
   PORT_TPE, /* (# 607) */
   PORT_TPE1, /* (# 608) */
   PORT_TPE2, /* (# 609) */
   PORT_TPE3, /* (# 610) */
   PORT_TPE4, /* (# 611) */
   PORT_TPE5, /* (# 612) */
   PORT_TPE6, /* (# 613) */
   PORT_UP, /* (# 614) */
   PORT_VLAN_AOVTP, /* (# 615) */
   PORT_VLAN_AOVTP1, /* (# 616) */
   PORT_VLAN_AOVTP2, /* (# 617) */
   PORT_VLAN_AOVTP3, /* (# 618) */
   PORT_VLAN_AOVTP4, /* (# 619) */
   PORT_VLAN_AOVTP5, /* (# 620) */
   PORT_VLAN_AOVTP6, /* (# 621) */
   PORT_VLAN_BYPASS, /* (# 622) */
   PORT_VLAN_BYPASS1, /* (# 623) */
   PORT_VLAN_BYPASS2, /* (# 624) */
   PORT_VLAN_BYPASS3, /* (# 625) */
   PORT_VLAN_BYPASS4, /* (# 626) */
   PORT_VLAN_BYPASS5, /* (# 627) */
   PORT_VLAN_BYPASS6, /* (# 628) */
   PORT_VLAN_DFID, /* (# 629) */
   PORT_VLAN_DFID1, /* (# 630) */
   PORT_VLAN_DFID2, /* (# 631) */
   PORT_VLAN_DFID3, /* (# 632) */
   PORT_VLAN_DFID4, /* (# 633) */
   PORT_VLAN_DFID5, /* (# 634) */
   PORT_VLAN_DFID6, /* (# 635) */
   PORT_VLAN_DVPM, /* (# 636) */
   PORT_VLAN_DVPM1, /* (# 637) */
   PORT_VLAN_DVPM2, /* (# 638) */
   PORT_VLAN_DVPM3, /* (# 639) */
   PORT_VLAN_DVPM4, /* (# 640) */
   PORT_VLAN_DVPM5, /* (# 641) */
   PORT_VLAN_DVPM6, /* (# 642) */
   PORT_VLAN_PP, /* (# 643) */
   PORT_VLAN_PP1, /* (# 644) */
   PORT_VLAN_PP2, /* (# 645) */
   PORT_VLAN_PP3, /* (# 646) */
   PORT_VLAN_PP4, /* (# 647) */
   PORT_VLAN_PP5, /* (# 648) */
   PORT_VLAN_PP6, /* (# 649) */
   PORT_VLAN_PPE, /* (# 650) */
   PORT_VLAN_PPE1, /* (# 651) */
   PORT_VLAN_PPE2, /* (# 652) */
   PORT_VLAN_PPE3, /* (# 653) */
   PORT_VLAN_PPE4, /* (# 654) */
   PORT_VLAN_PPE5, /* (# 655) */
   PORT_VLAN_PPE6, /* (# 656) */
   PORT_VLAN_PVID, /* (# 657) */
   PORT_VLAN_PVID1, /* (# 658) */
   PORT_VLAN_PVID2, /* (# 659) */
   PORT_VLAN_PVID3, /* (# 660) */
   PORT_VLAN_PVID4, /* (# 661) */
   PORT_VLAN_PVID5, /* (# 662) */
   PORT_VLAN_PVID6, /* (# 663) */
   PORT_VLAN_PVTAGMP, /* (# 664) */
   PORT_VLAN_PVTAGMP1, /* (# 665) */
   PORT_VLAN_PVTAGMP2, /* (# 666) */
   PORT_VLAN_PVTAGMP3, /* (# 667) */
   PORT_VLAN_PVTAGMP4, /* (# 668) */
   PORT_VLAN_PVTAGMP5, /* (# 669) */
   PORT_VLAN_PVTAGMP6, /* (# 670) */
   PORT_VLAN_TBVE, /* (# 671) */
   PORT_VLAN_TBVE1, /* (# 672) */
   PORT_VLAN_TBVE2, /* (# 673) */
   PORT_VLAN_TBVE3, /* (# 674) */
   PORT_VLAN_TBVE4, /* (# 675) */
   PORT_VLAN_TBVE5, /* (# 676) */
   PORT_VLAN_TBVE6, /* (# 677) */
   PORT_VLAN_VC, /* (# 678) */
   PORT_VLAN_VC1, /* (# 679) */
   PORT_VLAN_VC2, /* (# 680) */
   PORT_VLAN_VC3, /* (# 681) */
   PORT_VLAN_VC4, /* (# 682) */
   PORT_VLAN_VC5, /* (# 683) */
   PORT_VLAN_VC6, /* (# 684) */
   PORT_VLAN_VMCE, /* (# 685) */
   PORT_VLAN_VMCE1, /* (# 686) */
   PORT_VLAN_VMCE2, /* (# 687) */
   PORT_VLAN_VMCE3, /* (# 688) */
   PORT_VLAN_VMCE4, /* (# 689) */
   PORT_VLAN_VMCE5, /* (# 690) */
   PORT_VLAN_VMCE6, /* (# 691) */
   PORT_VLAN_VSD, /* (# 692) */
   PORT_VLAN_VSD1, /* (# 693) */
   PORT_VLAN_VSD2, /* (# 694) */
   PORT_VLAN_VSD3, /* (# 695) */
   PORT_VLAN_VSD4, /* (# 696) */
   PORT_VLAN_VSD5, /* (# 697) */
   PORT_VLAN_VSD6, /* (# 698) */
   PORT_VPE, /* (# 699) */
   PORT_VPE1, /* (# 700) */
   PORT_VPE2, /* (# 701) */
   PORT_VPE3, /* (# 702) */
   PORT_VPE4, /* (# 703) */
   PORT_VPE5, /* (# 704) */
   PORT_VPE6, /* (# 705) */
   PPPOE_SID, /* (# 706) */
   PROTOCOL_FILTER_APF, /* (# 707) */
   PROTOCOL_FILTER_APF1, /* (# 708) */
   PROTOCOL_FILTER_APF2, /* (# 709) */
   PROTOCOL_FILTER_APF3, /* (# 710) */
   PROTOCOL_FILTER_APF4, /* (# 711) */
   PROTOCOL_FILTER_APF5, /* (# 712) */
   PROTOCOL_FILTER_APF6, /* (# 713) */
   PROTOCOL_FILTER_APF7, /* (# 714) */
   PROTOCOL_FILTER_PFR0, /* (# 715) */
   PROTOCOL_FILTER_PFR01, /* (# 716) */
   PROTOCOL_FILTER_PFR02, /* (# 717) */
   PROTOCOL_FILTER_PFR03, /* (# 718) */
   PROTOCOL_FILTER_PFR1, /* (# 719) */
   PROTOCOL_FILTER_PFR11, /* (# 720) */
   PROTOCOL_FILTER_PFR12, /* (# 721) */
   PROTOCOL_FILTER_PFR13, /* (# 722) */
   PROTOCOL_FILTER_PFR2, /* (# 723) */
   PROTOCOL_FILTER_PFR21, /* (# 724) */
   PROTOCOL_FILTER_PFR3, /* (# 725) */
   PROTOCOL_FILTER_PFR31, /* (# 726) */
   RA00_ACT, /* (# 727) */
   RA00_ACT1, /* (# 728) */
   RA00_ACT2, /* (# 729) */
   RA00_ACT3, /* (# 730) */
   RA00_ACT4, /* (# 731) */
   RA00_ACT5, /* (# 732) */
   RA00_ACT6, /* (# 733) */
   RA00_ACT7, /* (# 734) */
   RA00_ACT8, /* (# 735) */
   RA00_ACT9, /* (# 736) */
   RA00_ACT10, /* (# 737) */
   RA00_ACT11, /* (# 738) */
   RA00_ACT12, /* (# 739) */
   RA00_ACT13, /* (# 740) */
   RA00_ACT14, /* (# 741) */
   RA00_ACT15, /* (# 742) */
   RA00_ACT16, /* (# 743) */
   RA00_ACT17, /* (# 744) */
   RA00_ACT18, /* (# 745) */
   RA00_ACT19, /* (# 746) */
   RA00_ACT20, /* (# 747) */
   RA00_ACT21, /* (# 748) */
   RA00_ACT22, /* (# 749) */
   RA00_ACT23, /* (# 750) */
   RA00_CV, /* (# 751) */
   RA00_CV1, /* (# 752) */
   RA00_CV2, /* (# 753) */
   RA00_CV3, /* (# 754) */
   RA00_CV4, /* (# 755) */
   RA00_CV5, /* (# 756) */
   RA00_CV6, /* (# 757) */
   RA00_CV7, /* (# 758) */
   RA00_CV8, /* (# 759) */
   RA00_CV9, /* (# 760) */
   RA00_CV10, /* (# 761) */
   RA00_CV11, /* (# 762) */
   RA00_CV12, /* (# 763) */
   RA00_CV13, /* (# 764) */
   RA00_CV14, /* (# 765) */
   RA00_CV15, /* (# 766) */
   RA00_CV16, /* (# 767) */
   RA00_CV17, /* (# 768) */
   RA00_CV18, /* (# 769) */
   RA00_CV19, /* (# 770) */
   RA00_CV20, /* (# 771) */
   RA00_CV21, /* (# 772) */
   RA00_CV22, /* (# 773) */
   RA00_CV23, /* (# 774) */
   RA00_MG, /* (# 775) */
   RA00_MG1, /* (# 776) */
   RA00_MG2, /* (# 777) */
   RA00_MG3, /* (# 778) */
   RA00_MG4, /* (# 779) */
   RA00_MG5, /* (# 780) */
   RA00_MG6, /* (# 781) */
   RA00_MG7, /* (# 782) */
   RA00_MG8, /* (# 783) */
   RA00_MG9, /* (# 784) */
   RA00_MG10, /* (# 785) */
   RA00_MG11, /* (# 786) */
   RA00_MG12, /* (# 787) */
   RA00_MG13, /* (# 788) */
   RA00_MG14, /* (# 789) */
   RA00_MG15, /* (# 790) */
   RA00_MG16, /* (# 791) */
   RA00_MG17, /* (# 792) */
   RA00_MG18, /* (# 793) */
   RA00_MG19, /* (# 794) */
   RA00_MG20, /* (# 795) */
   RA00_MG21, /* (# 796) */
   RA00_MG22, /* (# 797) */
   RA00_MG23, /* (# 798) */
   RA00_SPAN, /* (# 799) */
   RA00_SPAN1, /* (# 800) */
   RA00_SPAN2, /* (# 801) */
   RA00_SPAN3, /* (# 802) */
   RA00_SPAN4, /* (# 803) */
   RA00_SPAN5, /* (# 804) */
   RA00_SPAN6, /* (# 805) */
   RA00_SPAN7, /* (# 806) */
   RA00_SPAN8, /* (# 807) */
   RA00_SPAN9, /* (# 808) */
   RA00_SPAN10, /* (# 809) */
   RA00_SPAN11, /* (# 810) */
   RA00_SPAN12, /* (# 811) */
   RA00_SPAN13, /* (# 812) */
   RA00_SPAN14, /* (# 813) */
   RA00_SPAN15, /* (# 814) */
   RA00_SPAN16, /* (# 815) */
   RA00_SPAN17, /* (# 816) */
   RA00_SPAN18, /* (# 817) */
   RA00_SPAN19, /* (# 818) */
   RA00_SPAN20, /* (# 819) */
   RA00_SPAN21, /* (# 820) */
   RA00_SPAN22, /* (# 821) */
   RA00_SPAN23, /* (# 822) */
   RA00_TXTAG, /* (# 823) */
   RA00_TXTAG1, /* (# 824) */
   RA00_TXTAG2, /* (# 825) */
   RA00_TXTAG3, /* (# 826) */
   RA00_TXTAG4, /* (# 827) */
   RA00_TXTAG5, /* (# 828) */
   RA00_TXTAG6, /* (# 829) */
   RA00_TXTAG7, /* (# 830) */
   RA00_TXTAG8, /* (# 831) */
   RA00_TXTAG9, /* (# 832) */
   RA00_TXTAG10, /* (# 833) */
   RA00_TXTAG11, /* (# 834) */
   RA00_TXTAG12, /* (# 835) */
   RA00_TXTAG13, /* (# 836) */
   RA00_TXTAG14, /* (# 837) */
   RA00_TXTAG15, /* (# 838) */
   RA00_TXTAG16, /* (# 839) */
   RA00_TXTAG17, /* (# 840) */
   RA00_TXTAG18, /* (# 841) */
   RA00_TXTAG19, /* (# 842) */
   RA00_TXTAG20, /* (# 843) */
   RA00_TXTAG21, /* (# 844) */
   RA00_TXTAG22, /* (# 845) */
   RA00_TXTAG23, /* (# 846) */
   RA00_VALID, /* (# 847) */
   RA00_VALID1, /* (# 848) */
   RA00_VALID2, /* (# 849) */
   RA00_VALID3, /* (# 850) */
   RA00_VALID4, /* (# 851) */
   RA00_VALID5, /* (# 852) */
   RA00_VALID6, /* (# 853) */
   RA00_VALID7, /* (# 854) */
   RA00_VALID8, /* (# 855) */
   RA00_VALID9, /* (# 856) */
   RA00_VALID10, /* (# 857) */
   RA00_VALID11, /* (# 858) */
   RA00_VALID12, /* (# 859) */
   RA00_VALID13, /* (# 860) */
   RA00_VALID14, /* (# 861) */
   RA00_VALID15, /* (# 862) */
   RA00_VALID16, /* (# 863) */
   RA00_VALID17, /* (# 864) */
   RA00_VALID18, /* (# 865) */
   RA00_VALID19, /* (# 866) */
   RA00_VALID20, /* (# 867) */
   RA00_VALID21, /* (# 868) */
   RA00_VALID22, /* (# 869) */
   RA00_VALID23, /* (# 870) */
   RA01_ACT, /* (# 871) */
   RA01_ACT1, /* (# 872) */
   RA01_ACT2, /* (# 873) */
   RA01_ACT3, /* (# 874) */
   RA01_ACT4, /* (# 875) */
   RA01_ACT5, /* (# 876) */
   RA01_ACT6, /* (# 877) */
   RA01_ACT7, /* (# 878) */
   RA01_ACT8, /* (# 879) */
   RA01_ACT9, /* (# 880) */
   RA01_ACT10, /* (# 881) */
   RA01_ACT11, /* (# 882) */
   RA01_ACT12, /* (# 883) */
   RA01_ACT13, /* (# 884) */
   RA01_ACT14, /* (# 885) */
   RA01_ACT15, /* (# 886) */
   RA01_ACT16, /* (# 887) */
   RA01_ACT17, /* (# 888) */
   RA01_ACT18, /* (# 889) */
   RA01_ACT19, /* (# 890) */
   RA01_ACT20, /* (# 891) */
   RA01_ACT21, /* (# 892) */
   RA01_ACT22, /* (# 893) */
   RA01_ACT23, /* (# 894) */
   RA01_CV, /* (# 895) */
   RA01_CV1, /* (# 896) */
   RA01_CV2, /* (# 897) */
   RA01_CV3, /* (# 898) */
   RA01_CV4, /* (# 899) */
   RA01_CV5, /* (# 900) */
   RA01_CV6, /* (# 901) */
   RA01_CV7, /* (# 902) */
   RA01_CV8, /* (# 903) */
   RA01_CV9, /* (# 904) */
   RA01_CV10, /* (# 905) */
   RA01_CV11, /* (# 906) */
   RA01_CV12, /* (# 907) */
   RA01_CV13, /* (# 908) */
   RA01_CV14, /* (# 909) */
   RA01_CV15, /* (# 910) */
   RA01_CV16, /* (# 911) */
   RA01_CV17, /* (# 912) */
   RA01_CV18, /* (# 913) */
   RA01_CV19, /* (# 914) */
   RA01_CV20, /* (# 915) */
   RA01_CV21, /* (# 916) */
   RA01_CV22, /* (# 917) */
   RA01_CV23, /* (# 918) */
   RA01_MG, /* (# 919) */
   RA01_MG1, /* (# 920) */
   RA01_MG2, /* (# 921) */
   RA01_MG3, /* (# 922) */
   RA01_MG4, /* (# 923) */
   RA01_MG5, /* (# 924) */
   RA01_MG6, /* (# 925) */
   RA01_MG7, /* (# 926) */
   RA01_MG8, /* (# 927) */
   RA01_MG9, /* (# 928) */
   RA01_MG10, /* (# 929) */
   RA01_MG11, /* (# 930) */
   RA01_MG12, /* (# 931) */
   RA01_MG13, /* (# 932) */
   RA01_MG14, /* (# 933) */
   RA01_MG15, /* (# 934) */
   RA01_MG16, /* (# 935) */
   RA01_MG17, /* (# 936) */
   RA01_MG18, /* (# 937) */
   RA01_MG19, /* (# 938) */
   RA01_MG20, /* (# 939) */
   RA01_MG21, /* (# 940) */
   RA01_MG22, /* (# 941) */
   RA01_MG23, /* (# 942) */
   RA01_SPAN, /* (# 943) */
   RA01_SPAN1, /* (# 944) */
   RA01_SPAN2, /* (# 945) */
   RA01_SPAN3, /* (# 946) */
   RA01_SPAN4, /* (# 947) */
   RA01_SPAN5, /* (# 948) */
   RA01_SPAN6, /* (# 949) */
   RA01_SPAN7, /* (# 950) */
   RA01_SPAN8, /* (# 951) */
   RA01_SPAN9, /* (# 952) */
   RA01_SPAN10, /* (# 953) */
   RA01_SPAN11, /* (# 954) */
   RA01_SPAN12, /* (# 955) */
   RA01_SPAN13, /* (# 956) */
   RA01_SPAN14, /* (# 957) */
   RA01_SPAN15, /* (# 958) */
   RA01_SPAN16, /* (# 959) */
   RA01_SPAN17, /* (# 960) */
   RA01_SPAN18, /* (# 961) */
   RA01_SPAN19, /* (# 962) */
   RA01_SPAN20, /* (# 963) */
   RA01_SPAN21, /* (# 964) */
   RA01_SPAN22, /* (# 965) */
   RA01_SPAN23, /* (# 966) */
   RA01_TXTAG, /* (# 967) */
   RA01_TXTAG1, /* (# 968) */
   RA01_TXTAG2, /* (# 969) */
   RA01_TXTAG3, /* (# 970) */
   RA01_TXTAG4, /* (# 971) */
   RA01_TXTAG5, /* (# 972) */
   RA01_TXTAG6, /* (# 973) */
   RA01_TXTAG7, /* (# 974) */
   RA01_TXTAG8, /* (# 975) */
   RA01_TXTAG9, /* (# 976) */
   RA01_TXTAG10, /* (# 977) */
   RA01_TXTAG11, /* (# 978) */
   RA01_TXTAG12, /* (# 979) */
   RA01_TXTAG13, /* (# 980) */
   RA01_TXTAG14, /* (# 981) */
   RA01_TXTAG15, /* (# 982) */
   RA01_TXTAG16, /* (# 983) */
   RA01_TXTAG17, /* (# 984) */
   RA01_TXTAG18, /* (# 985) */
   RA01_TXTAG19, /* (# 986) */
   RA01_TXTAG20, /* (# 987) */
   RA01_TXTAG21, /* (# 988) */
   RA01_TXTAG22, /* (# 989) */
   RA01_TXTAG23, /* (# 990) */
   RA01_VALID, /* (# 991) */
   RA01_VALID1, /* (# 992) */
   RA01_VALID2, /* (# 993) */
   RA01_VALID3, /* (# 994) */
   RA01_VALID4, /* (# 995) */
   RA01_VALID5, /* (# 996) */
   RA01_VALID6, /* (# 997) */
   RA01_VALID7, /* (# 998) */
   RA01_VALID8, /* (# 999) */
   RA01_VALID9, /* (# 1000) */
   RA01_VALID10, /* (# 1001) */
   RA01_VALID11, /* (# 1002) */
   RA01_VALID12, /* (# 1003) */
   RA01_VALID13, /* (# 1004) */
   RA01_VALID14, /* (# 1005) */
   RA01_VALID15, /* (# 1006) */
   RA01_VALID16, /* (# 1007) */
   RA01_VALID17, /* (# 1008) */
   RA01_VALID18, /* (# 1009) */
   RA01_VALID19, /* (# 1010) */
   RA01_VALID20, /* (# 1011) */
   RA01_VALID21, /* (# 1012) */
   RA01_VALID22, /* (# 1013) */
   RA01_VALID23, /* (# 1014) */
   RA02_ACT, /* (# 1015) */
   RA02_ACT1, /* (# 1016) */
   RA02_ACT2, /* (# 1017) */
   RA02_ACT3, /* (# 1018) */
   RA02_ACT4, /* (# 1019) */
   RA02_ACT5, /* (# 1020) */
   RA02_ACT6, /* (# 1021) */
   RA02_ACT7, /* (# 1022) */
   RA02_ACT8, /* (# 1023) */
   RA02_ACT9, /* (# 1024) */
   RA02_ACT10, /* (# 1025) */
   RA02_ACT11, /* (# 1026) */
   RA02_CV, /* (# 1027) */
   RA02_CV1, /* (# 1028) */
   RA02_CV2, /* (# 1029) */
   RA02_CV3, /* (# 1030) */
   RA02_CV4, /* (# 1031) */
   RA02_CV5, /* (# 1032) */
   RA02_CV6, /* (# 1033) */
   RA02_CV7, /* (# 1034) */
   RA02_CV8, /* (# 1035) */
   RA02_CV9, /* (# 1036) */
   RA02_CV10, /* (# 1037) */
   RA02_CV11, /* (# 1038) */
   RA02_MG, /* (# 1039) */
   RA02_MG1, /* (# 1040) */
   RA02_MG2, /* (# 1041) */
   RA02_MG3, /* (# 1042) */
   RA02_MG4, /* (# 1043) */
   RA02_MG5, /* (# 1044) */
   RA02_MG6, /* (# 1045) */
   RA02_MG7, /* (# 1046) */
   RA02_MG8, /* (# 1047) */
   RA02_MG9, /* (# 1048) */
   RA02_MG10, /* (# 1049) */
   RA02_MG11, /* (# 1050) */
   RA02_SPAN, /* (# 1051) */
   RA02_SPAN1, /* (# 1052) */
   RA02_SPAN2, /* (# 1053) */
   RA02_SPAN3, /* (# 1054) */
   RA02_SPAN4, /* (# 1055) */
   RA02_SPAN5, /* (# 1056) */
   RA02_SPAN6, /* (# 1057) */
   RA02_SPAN7, /* (# 1058) */
   RA02_SPAN8, /* (# 1059) */
   RA02_SPAN9, /* (# 1060) */
   RA02_SPAN10, /* (# 1061) */
   RA02_SPAN11, /* (# 1062) */
   RA02_TXTAG, /* (# 1063) */
   RA02_TXTAG1, /* (# 1064) */
   RA02_TXTAG2, /* (# 1065) */
   RA02_TXTAG3, /* (# 1066) */
   RA02_TXTAG4, /* (# 1067) */
   RA02_TXTAG5, /* (# 1068) */
   RA02_TXTAG6, /* (# 1069) */
   RA02_TXTAG7, /* (# 1070) */
   RA02_TXTAG8, /* (# 1071) */
   RA02_TXTAG9, /* (# 1072) */
   RA02_TXTAG10, /* (# 1073) */
   RA02_TXTAG11, /* (# 1074) */
   RA02_VALID, /* (# 1075) */
   RA02_VALID1, /* (# 1076) */
   RA02_VALID2, /* (# 1077) */
   RA02_VALID3, /* (# 1078) */
   RA02_VALID4, /* (# 1079) */
   RA02_VALID5, /* (# 1080) */
   RA02_VALID6, /* (# 1081) */
   RA02_VALID7, /* (# 1082) */
   RA02_VALID8, /* (# 1083) */
   RA02_VALID9, /* (# 1084) */
   RA02_VALID10, /* (# 1085) */
   RA02_VALID11, /* (# 1086) */
   RA03_ACT, /* (# 1087) */
   RA03_ACT1, /* (# 1088) */
   RA03_ACT2, /* (# 1089) */
   RA03_ACT3, /* (# 1090) */
   RA03_ACT4, /* (# 1091) */
   RA03_ACT5, /* (# 1092) */
   RA03_ACT6, /* (# 1093) */
   RA03_ACT7, /* (# 1094) */
   RA03_ACT8, /* (# 1095) */
   RA03_ACT9, /* (# 1096) */
   RA03_ACT10, /* (# 1097) */
   RA03_ACT11, /* (# 1098) */
   RA03_CV, /* (# 1099) */
   RA03_CV1, /* (# 1100) */
   RA03_CV2, /* (# 1101) */
   RA03_CV3, /* (# 1102) */
   RA03_CV4, /* (# 1103) */
   RA03_CV5, /* (# 1104) */
   RA03_CV6, /* (# 1105) */
   RA03_CV7, /* (# 1106) */
   RA03_CV8, /* (# 1107) */
   RA03_CV9, /* (# 1108) */
   RA03_CV10, /* (# 1109) */
   RA03_CV11, /* (# 1110) */
   RA03_MG, /* (# 1111) */
   RA03_MG1, /* (# 1112) */
   RA03_MG2, /* (# 1113) */
   RA03_MG3, /* (# 1114) */
   RA03_MG4, /* (# 1115) */
   RA03_MG5, /* (# 1116) */
   RA03_MG6, /* (# 1117) */
   RA03_MG7, /* (# 1118) */
   RA03_MG8, /* (# 1119) */
   RA03_MG9, /* (# 1120) */
   RA03_MG10, /* (# 1121) */
   RA03_MG11, /* (# 1122) */
   RA03_SPAN, /* (# 1123) */
   RA03_SPAN1, /* (# 1124) */
   RA03_SPAN2, /* (# 1125) */
   RA03_SPAN3, /* (# 1126) */
   RA03_SPAN4, /* (# 1127) */
   RA03_SPAN5, /* (# 1128) */
   RA03_SPAN6, /* (# 1129) */
   RA03_SPAN7, /* (# 1130) */
   RA03_SPAN8, /* (# 1131) */
   RA03_SPAN9, /* (# 1132) */
   RA03_SPAN10, /* (# 1133) */
   RA03_SPAN11, /* (# 1134) */
   RA03_TXTAG, /* (# 1135) */
   RA03_TXTAG1, /* (# 1136) */
   RA03_TXTAG2, /* (# 1137) */
   RA03_TXTAG3, /* (# 1138) */
   RA03_TXTAG4, /* (# 1139) */
   RA03_TXTAG5, /* (# 1140) */
   RA03_TXTAG6, /* (# 1141) */
   RA03_TXTAG7, /* (# 1142) */
   RA03_TXTAG8, /* (# 1143) */
   RA03_TXTAG9, /* (# 1144) */
   RA03_TXTAG10, /* (# 1145) */
   RA03_TXTAG11, /* (# 1146) */
   RA03_VALID, /* (# 1147) */
   RA03_VALID1, /* (# 1148) */
   RA03_VALID2, /* (# 1149) */
   RA03_VALID3, /* (# 1150) */
   RA03_VALID4, /* (# 1151) */
   RA03_VALID5, /* (# 1152) */
   RA03_VALID6, /* (# 1153) */
   RA03_VALID7, /* (# 1154) */
   RA03_VALID8, /* (# 1155) */
   RA03_VALID9, /* (# 1156) */
   RA03_VALID10, /* (# 1157) */
   RA03_VALID11, /* (# 1158) */
   RMON_BAS, /* (# 1159) */
   RMON_CAC, /* (# 1160) */
   RMON_COUNTER, /* (# 1161) */
   RMON_HIGH_COUNTER, /* (# 1162) */
   RMON_LOW_COUNTER, /* (# 1163) */
   RMON_OFFSET, /* (# 1164) */
   RMON_PORTC, /* (# 1165) */
   TYPE_FILTER_ATF, /* (# 1166) */
   TYPE_FILTER_ATF1, /* (# 1167) */
   TYPE_FILTER_ATF2, /* (# 1168) */
   TYPE_FILTER_ATF3, /* (# 1169) */
   TYPE_FILTER_ATF4, /* (# 1170) */
   TYPE_FILTER_ATF5, /* (# 1171) */
   TYPE_FILTER_ATF6, /* (# 1172) */
   TYPE_FILTER_ATF7, /* (# 1173) */
   TYPE_FILTER_QTF, /* (# 1174) */
   TYPE_FILTER_QTF1, /* (# 1175) */
   TYPE_FILTER_QTF2, /* (# 1176) */
   TYPE_FILTER_QTF3, /* (# 1177) */
   TYPE_FILTER_QTF4, /* (# 1178) */
   TYPE_FILTER_QTF5, /* (# 1179) */
   TYPE_FILTER_QTF6, /* (# 1180) */
   TYPE_FILTER_QTF7, /* (# 1181) */
   TYPE_FILTER_VCET0, /* (# 1182) */
   TYPE_FILTER_VCET01, /* (# 1183) */
   TYPE_FILTER_VCET02, /* (# 1184) */
   TYPE_FILTER_VCET03, /* (# 1185) */
   TYPE_FILTER_VCET1, /* (# 1186) */
   TYPE_FILTER_VCET11, /* (# 1187) */
   TYPE_FILTER_VCET12, /* (# 1188) */
   TYPE_FILTER_VCET13, /* (# 1189) */
   TYPE_FILTER_VCET_ALL, /* (# 1190) */
   TYPE_FILTER_VCET_ALL1, /* (# 1191) */
   TYPE_FILTER_VCET_ALL2, /* (# 1192) */
   TYPE_FILTER_VCET_ALL3, /* (# 1193) */
   TYPE_FILTER_VCET_ALL4, /* (# 1194) */
   TYPE_FILTER_VCET_ALL5, /* (# 1195) */
   TYPE_FILTER_VCET_ALL6, /* (# 1196) */
   TYPE_FILTER_VCET_ALL7, /* (# 1197) */
   VLAN_FILTER_M, /* (# 1198) */
   VLAN_FILTER_M1, /* (# 1199) */
   VLAN_FILTER_M2, /* (# 1200) */
   VLAN_FILTER_M3, /* (# 1201) */
   VLAN_FILTER_M4, /* (# 1202) */
   VLAN_FILTER_M5, /* (# 1203) */
   VLAN_FILTER_M6, /* (# 1204) */
   VLAN_FILTER_M7, /* (# 1205) */
   VLAN_FILTER_M8, /* (# 1206) */
   VLAN_FILTER_M9, /* (# 1207) */
   VLAN_FILTER_M10, /* (# 1208) */
   VLAN_FILTER_M11, /* (# 1209) */
   VLAN_FILTER_M12, /* (# 1210) */
   VLAN_FILTER_M13, /* (# 1211) */
   VLAN_FILTER_M14, /* (# 1212) */
   VLAN_FILTER_M15, /* (# 1213) */
   VLAN_FILTER_TM, /* (# 1214) */
   VLAN_FILTER_TM1, /* (# 1215) */
   VLAN_FILTER_TM2, /* (# 1216) */
   VLAN_FILTER_TM3, /* (# 1217) */
   VLAN_FILTER_TM4, /* (# 1218) */
   VLAN_FILTER_TM5, /* (# 1219) */
   VLAN_FILTER_TM6, /* (# 1220) */
   VLAN_FILTER_TM7, /* (# 1221) */
   VLAN_FILTER_TM8, /* (# 1222) */
   VLAN_FILTER_TM9, /* (# 1223) */
   VLAN_FILTER_TM10, /* (# 1224) */
   VLAN_FILTER_TM11, /* (# 1225) */
   VLAN_FILTER_TM12, /* (# 1226) */
   VLAN_FILTER_TM13, /* (# 1227) */
   VLAN_FILTER_TM14, /* (# 1228) */
   VLAN_FILTER_TM15, /* (# 1229) */
   VLAN_FILTER_VFID, /* (# 1230) */
   VLAN_FILTER_VFID1, /* (# 1231) */
   VLAN_FILTER_VFID2, /* (# 1232) */
   VLAN_FILTER_VFID3, /* (# 1233) */
   VLAN_FILTER_VFID4, /* (# 1234) */
   VLAN_FILTER_VFID5, /* (# 1235) */
   VLAN_FILTER_VFID6, /* (# 1236) */
   VLAN_FILTER_VFID7, /* (# 1237) */
   VLAN_FILTER_VFID8, /* (# 1238) */
   VLAN_FILTER_VFID9, /* (# 1239) */
   VLAN_FILTER_VFID10, /* (# 1240) */
   VLAN_FILTER_VFID11, /* (# 1241) */
   VLAN_FILTER_VFID12, /* (# 1242) */
   VLAN_FILTER_VFID13, /* (# 1243) */
   VLAN_FILTER_VFID14, /* (# 1244) */
   VLAN_FILTER_VFID15, /* (# 1245) */
   VLAN_FILTER_VID, /* (# 1246) */
   VLAN_FILTER_VID1, /* (# 1247) */
   VLAN_FILTER_VID2, /* (# 1248) */
   VLAN_FILTER_VID3, /* (# 1249) */
   VLAN_FILTER_VID4, /* (# 1250) */
   VLAN_FILTER_VID5, /* (# 1251) */
   VLAN_FILTER_VID6, /* (# 1252) */
   VLAN_FILTER_VID7, /* (# 1253) */
   VLAN_FILTER_VID8, /* (# 1254) */
   VLAN_FILTER_VID9, /* (# 1255) */
   VLAN_FILTER_VID10, /* (# 1256) */
   VLAN_FILTER_VID11, /* (# 1257) */
   VLAN_FILTER_VID12, /* (# 1258) */
   VLAN_FILTER_VID13, /* (# 1259) */
   VLAN_FILTER_VID14, /* (# 1260) */
   VLAN_FILTER_VID15, /* (# 1261) */
   VLAN_FILTER_VP, /* (# 1262) */
   VLAN_FILTER_VP1, /* (# 1263) */
   VLAN_FILTER_VP2, /* (# 1264) */
   VLAN_FILTER_VP3, /* (# 1265) */
   VLAN_FILTER_VP4, /* (# 1266) */
   VLAN_FILTER_VP5, /* (# 1267) */
   VLAN_FILTER_VP6, /* (# 1268) */
   VLAN_FILTER_VP7, /* (# 1269) */
   VLAN_FILTER_VP8, /* (# 1270) */
   VLAN_FILTER_VP9, /* (# 1271) */
   VLAN_FILTER_VP10, /* (# 1272) */
   VLAN_FILTER_VP11, /* (# 1273) */
   VLAN_FILTER_VP12, /* (# 1274) */
   VLAN_FILTER_VP13, /* (# 1275) */
   VLAN_FILTER_VP14, /* (# 1276) */
   VLAN_FILTER_VP15, /* (# 1277) */
   VLAN_FILTER_VV, /* (# 1278) */
   VLAN_FILTER_VV1, /* (# 1279) */
   VLAN_FILTER_VV2, /* (# 1280) */
   VLAN_FILTER_VV3, /* (# 1281) */
   VLAN_FILTER_VV4, /* (# 1282) */
   VLAN_FILTER_VV5, /* (# 1283) */
   VLAN_FILTER_VV6, /* (# 1284) */
   VLAN_FILTER_VV7, /* (# 1285) */
   VLAN_FILTER_VV8, /* (# 1286) */
   VLAN_FILTER_VV9, /* (# 1287) */
   VLAN_FILTER_VV10, /* (# 1288) */
   VLAN_FILTER_VV11, /* (# 1289) */
   VLAN_FILTER_VV12, /* (# 1290) */
   VLAN_FILTER_VV13, /* (# 1291) */
   VLAN_FILTER_VV14, /* (# 1292) */
   VLAN_FILTER_VV15, /* (# 1293) */
   COMMON_BIT_LATEST /* (# 1294) */
}IFX_ETHSW_regMapperSelector_t;

#endif /* #ifndef _IFX_ETHSW_REGMAPPERSELECTOR_H */
