#ifndef __ASM_MACH_AR7240_MANGLE_PORT_H
#define __ASM_MACH_AR7240_MANGLE_PORT_H

#define __swizzle_addr_b(port)	((port) ^ 3)
#define __swizzle_addr_w(port)	((port) ^ 2)
#define __swizzle_addr_l(port)	(port)
#define __swizzle_addr_q(port)	(port)
/*
 * Raw operations are never swapped in software.  OTOH values that raw
 * operations are working on may or may not have been swapped by the bus
 * hardware.  An example use would be for flash memory that's used for
 * execute in place.
 */
#if 0 /*--- sind in mach/mips/include/asm/io.h definiert ---*/
# define __raw_ioswabb(x)	(x)
# define __raw_ioswabw(x)	(x)
# define __raw_ioswabl(x)	(x)
# define __raw_ioswabq(x)	(x)
# define ____raw_ioswabq(x)	(x)
#endif

/*
 * Sane hardware offers swapping of PCI/ISA I/O space accesses in hardware;
 * less sane hardware forces software to fiddle with this...
 *
 * Regardless, if the host bus endianness mismatches that of PCI/ISA, then
 * you can't have the numerical value of data and byte addresses within
 * multibyte quantities both preserved at the same time.  Hence two
 * variations of functions: non-prefixed ones that preserve the value
 * and prefixed ones that preserve byte addresses.  The latters are
 * typically used for moving raw data between a peripheral and memory (cf.
 * string I/O functions), hence the "mem_" prefix.
 */
#if defined(CONFIG_SWAP_IO_SPACE)

# define ioswabb(a, x)		(x)
# define mem_ioswabb(a, x)		(x)
# ifdef CONFIG_SGI_IP22
/*
 * IP22 seems braindead enough to swap 16bits values in hardware, but
 * not 32bits.  Go figure... Can't tell without documentation.
 */
#  define ioswabw(a, x)		(x)
#  define mem_ioswabw(a, x)	le16_to_cpu(x)
# else
#  define ioswabw(a, x)		le16_to_cpu(x)
#  define mem_ioswabw(a, x)	(x)
# endif
# define ioswabl(a, x)		le32_to_cpu(x)
# define mem_ioswabl(a, x)		(x)
# define ioswabq(a, x)		le64_to_cpu(x)
# define mem_ioswabq(a, x)		(x)

#else

# define ioswabb(a, x)		(x)
# define mem_ioswabb(a, x)		(x)
# define ioswabw(a, x)		(x)
# define mem_ioswabw(a, x)		cpu_to_le16(x)
# define ioswabl(a, x)		(x)
# define mem_ioswabl(a, x)		cpu_to_le32(x)
# define ioswabq(a, x)		(x)
# define mem_ioswabq(a, x)		cpu_to_le32(x)

#endif

#define __mem_ioswabb(a, x)  mem_ioswabb(a, x)
#define __mem_ioswabw(a, x)  mem_ioswabw(a, x)
#define __mem_ioswabl(a, x)  mem_ioswabl(a, x)
#define __mem_ioswabq(a, x)  mem_ioswabq(a, x)

#endif /* __ASM_MACH_AR7240_MANGLE_PORT_H */
