#ifndef VR9_INTERRUPT_TABLE__H
#define VR9_INTERRUPT_TABLE__H

#if defined(CONFIG_VR9)

#ifdef CONFIG_MIPS_MT
  #define NR_IRQS                       (MIPSCPU_INT_BASE + 2)  /* Largest number of ints of all machines plus timer + 2 software IRQs */
#else
  #define NR_IRQS                       (MIPSCPU_INT_BASE)      /* Largest number of ints of all machines plus timer  */
#endif

struct _infineon_irq_index {
    int cpu_mask;
    int cpu_used;
    char *name;
    int second;
    int (*func)(int);
} infineon_irq_index[NR_IRQS] = {
    [INT_NUM_IM0_IRL0   ] = { .cpu_used = 1, .name = "MPS Status 0", .second = 0, .func = NULL, .cpu_mask = 2 },
    [INT_NUM_IM0_IRL1   ] = { .cpu_used = 1, .name = "MPS Status 1", .second = 0, .func = NULL, .cpu_mask = 2 },
    [INT_NUM_IM0_IRL2   ] = { .cpu_used = 1, .name = "MPS Status 2", .second = 0, .func = NULL, .cpu_mask = 2 },
    [INT_NUM_IM0_IRL3   ] = { .cpu_used = 1, .name = "MPS Status 3", .second = 0, .func = NULL, .cpu_mask = 2 },
    [INT_NUM_IM0_IRL4   ] = { .cpu_used = 1, .name = "MPS Status 4", .second = 0, .func = NULL, .cpu_mask = 2 },
    [INT_NUM_IM0_IRL5   ] = { .cpu_used = 1, .name = "MPS Status 5", .second = 0, .func = NULL, .cpu_mask = 2 },
    [INT_NUM_IM0_IRL6   ] = { .cpu_used = 1, .name = "MPS Status 6", .second = 0, .func = NULL, .cpu_mask = 2 },
    [INT_NUM_IM0_IRL7   ] = { .cpu_used = 1, .name = "MPS Semaphore", .second = 0, .func = NULL, .cpu_mask = 2 },
    [INT_NUM_IM0_IRL8   ] = { .cpu_used = 1, .name = "MPS Global", .second = 0, .func = NULL, .cpu_mask = 2 },
    [INT_NUM_IM0_IRL9   ] = { .cpu_used = 0, .name = "", .second = 0, .func = NULL, .cpu_mask = 0 },
    [INT_NUM_IM0_IRL10  ] = { .cpu_used = 0, .name = "", .second = 0, .func = NULL, .cpu_mask = 0 },
    [INT_NUM_IM0_IRL11  ] = { .cpu_used = 0, .name = "", .second = 0, .func = NULL, .cpu_mask = 0 },
    [INT_NUM_IM0_IRL12  ] = { .cpu_used = 0, .name = "", .second = 0, .func = NULL, .cpu_mask = 0 },
    [INT_NUM_IM0_IRL13  ] = { .cpu_used = 1, .name = "DMA FCC", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM0_IRL14  ] = { .cpu_used = 1, .name = "SPI Rx", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM0_IRL15  ] = { .cpu_used = 1, .name = "SPI Tx", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM0_IRL16  ] = { .cpu_used = 1, .name = "SPI Error", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM0_IRL17  ] = { .cpu_used = 1, .name = "SPI Frame", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM0_IRL18  ] = { .cpu_used = 1, .name = "SDIO 0", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM0_IRL19  ] = { .cpu_used = 1, .name = "SDIO 1", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM0_IRL20  ] = { .cpu_used = 1, .name = "SDIO Interface", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM0_IRL21  ] = { .cpu_used = 1, .name = "USIF TX INT", .second = 0, .func = NULL, .cpu_mask = 1 },
    [INT_NUM_IM0_IRL22  ] = { .cpu_used = 1, .name = "EBU", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM0_IRL23  ] = { .cpu_used = 1, .name = "MBox 0", .second = 1, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM0_IRL24  ] = { .cpu_used = 1, .name = "MBox 1", .second = 1, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM0_IRL25  ] = { .cpu_used = 1, .name = "FPI Master Bus BCU", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM0_IRL26  ] = { .cpu_used = 1, .name = "DEU Hashing ARC", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM0_IRL27  ] = { .cpu_used = 1, .name = "DEU DES/3DES", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM0_IRL28  ] = { .cpu_used = 1, .name = "DEU AES", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM0_IRL29  ] = { .cpu_used = 1, .name = "DEU Hashing SHA/MD5", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM0_IRL30  ] = { .cpu_used = 1, .name = "MSI_IR D", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM0_IRL31  ] = { .cpu_used = 0, .name = "", .second = 0, .func = NULL, .cpu_mask = 0 },
    [INT_NUM_IM1_IRL0   ] = { .cpu_used = 1, .name = "EIU 3", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM1_IRL1   ] = { .cpu_used = 1, .name = "EIU 4", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM1_IRL2   ] = { .cpu_used = 1, .name = "EIU 5", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM1_IRL3   ] = { .cpu_used = 0, .name = "", .second = 0, .func = NULL, .cpu_mask = 0 },
    [INT_NUM_IM1_IRL4   ] = { .cpu_used = 0, .name = "", .second = 0, .func = NULL, .cpu_mask = 0 },
    [INT_NUM_IM1_IRL5   ] = { .cpu_used = 0, .name = "", .second = 0, .func = NULL, .cpu_mask = 0 },
    [INT_NUM_IM1_IRL6   ] = { .cpu_used = 0, .name = "", .second = 0, .func = NULL, .cpu_mask = 0 },
    [INT_NUM_IM1_IRL7   ] = { .cpu_used = 0, .name = "", .second = 0, .func = NULL, .cpu_mask = 0 },
    [INT_NUM_IM1_IRL8   ] = { .cpu_used = 0, .name = "", .second = 0, .func = NULL, .cpu_mask = 0 },
    [INT_NUM_IM1_IRL9   ] = { .cpu_used = 1, .name = "MPS Status 0", .second = 1, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM1_IRL10  ] = { .cpu_used = 1, .name = "MPS Status 1", .second = 1, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM1_IRL11  ] = { .cpu_used = 1, .name = "MPS Status 2", .second = 1, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM1_IRL12  ] = { .cpu_used = 1, .name = "MPS Status 3", .second = 1, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM1_IRL13  ] = { .cpu_used = 1, .name = "MPS Status 4", .second = 1, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM1_IRL14  ] = { .cpu_used = 1, .name = "MPS Status 5", .second = 1, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM1_IRL15  ] = { .cpu_used = 1, .name = "MPS Status 6", .second = 1, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM1_IRL16  ] = { .cpu_used = 1, .name = "GETH Switch", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM1_IRL17  ] = { .cpu_used = 1, .name = "PCI", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM1_IRL18  ] = { .cpu_used = 1, .name = "PCI Power change", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM1_IRL19  ] = { .cpu_used = 1, .name = "PCM Tx", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM1_IRL20  ] = { .cpu_used = 1, .name = "PCM Rx", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM1_IRL21  ] = { .cpu_used = 1, .name = "DSL Dying Gasp", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM1_IRL22  ] = { .cpu_used = 1, .name = "USB0", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM1_IRL23  ] = { .cpu_used = 1, .name = "Digital frontend mailbox", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM1_IRL24  ] = { .cpu_used = 1, .name = "Analog fronend overload detect", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM1_IRL25  ] = { .cpu_used = 1, .name = "FPI slave BCU0", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM1_IRL26  ] = { .cpu_used = 1, .name = "EIU 2", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM1_IRL27  ] = { .cpu_used = 1, .name = "SBIU Error", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM1_IRL28  ] = { .cpu_used = 1, .name = "USB 0 Overcurrent detect", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM1_IRL29  ] = { .cpu_used = 1, .name = "PPE Mbox 2", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM1_IRL30  ] = { .cpu_used = 1, .name = "DMA Channel 17", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM1_IRL31  ] = { .cpu_used = 1, .name = "PPE QSB", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM2_IRL0   ] = { .cpu_used = 1, .name = "DMA Channel 0", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM2_IRL1   ] = { .cpu_used = 1, .name = "DMA Channel 1", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM2_IRL2   ] = { .cpu_used = 1, .name = "DMA Channel 2", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM2_IRL3   ] = { .cpu_used = 1, .name = "DMA Channel 3", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM2_IRL4   ] = { .cpu_used = 1, .name = "DMA Channel 4", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM2_IRL5   ] = { .cpu_used = 1, .name = "DMA Channel 5", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM2_IRL6   ] = { .cpu_used = 1, .name = "DMA Channel 6", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM2_IRL7   ] = { .cpu_used = 1, .name = "DMA Channel 7", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM2_IRL8   ] = { .cpu_used = 1, .name = "DMA Channel 8", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM2_IRL9   ] = { .cpu_used = 1, .name = "DMA Channel 9", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM2_IRL10  ] = { .cpu_used = 1, .name = "DMA Channel 10", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM2_IRL11  ] = { .cpu_used = 1, .name = "DMA Channel 11", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM2_IRL12  ] = { .cpu_used = 1, .name = "IM2_IRL12", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM2_IRL13  ] = { .cpu_used = 1, .name = "IM2_IRL13", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM2_IRL14  ] = { .cpu_used = 1, .name = "IM2_IRL14", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM2_IRL15  ] = { .cpu_used = 1, .name = "IM2_IRL15", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM2_IRL16  ] = { .cpu_used = 1, .name = "DMA Channel 18", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM2_IRL17  ] = { .cpu_used = 1, .name = "PCI", .second = 1, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM2_IRL18  ] = { .cpu_used = 1, .name = "PCI Power", .second = 1, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM2_IRL19  ] = { .cpu_used = 1, .name = "USB1", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM2_IRL20  ] = { .cpu_used = 1, .name = "Data Interface Idle", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM2_IRL21  ] = { .cpu_used = 1, .name = "DMA Channel 19", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM2_IRL22  ] = { .cpu_used = 1, .name = "Data Interface Call", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM2_IRL23  ] = { .cpu_used = 1, .name = "PPE Mbox 0", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM2_IRL24  ] = { .cpu_used = 1, .name = "PPE Mbox 1", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM2_IRL25  ] = { .cpu_used = 1, .name = "DMA Channel 12", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM2_IRL26  ] = { .cpu_used = 1, .name = "DMA Channel 13", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM2_IRL27  ] = { .cpu_used = 1, .name = "DMA Channel 14", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM2_IRL28  ] = { .cpu_used = 1, .name = "DMA Channel 15", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM2_IRL29  ] = { .cpu_used = 1, .name = "DMA Channel 16", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM2_IRL30  ] = { .cpu_used = 1, .name = "EIU 6", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM2_IRL31  ] = { .cpu_used = 1, .name = "8KHz", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM3_IRL0   ] = { .cpu_used = 1, .name = "HS NAND", .second = 1, .func = NULL, .cpu_mask = 1 },
    [INT_NUM_IM3_IRL1   ] = { .cpu_used = 0, .name = "", .second = 0, .func = NULL, .cpu_mask = 0 },
    [INT_NUM_IM3_IRL2   ] = { .cpu_used = 1, .name = "SSC True Complete", .second = 1, .func = NULL, .cpu_mask = 1 },
    [INT_NUM_IM3_IRL3   ] = { .cpu_used = 1, .name = "USIF Error", .second = 1, .func = NULL, .cpu_mask = 1 },
    [INT_NUM_IM3_IRL4   ] = { .cpu_used = 1, .name = "USIF State change", .second = 1, .func = NULL, .cpu_mask = 1 },
    [INT_NUM_IM3_IRL5   ] = { .cpu_used = 1, .name = "USIF Autobaud detect", .second = 1, .func = NULL, .cpu_mask = 1 },
    [INT_NUM_IM3_IRL6   ] = { .cpu_used = 1, .name = "USIF Wakeup", .second = 1, .func = NULL, .cpu_mask = 1 },
    [INT_NUM_IM3_IRL7   ] = { .cpu_used = 1, .name = "ASC1 Tx", .second = 0, .func = NULL, .cpu_mask = 1 },
    [INT_NUM_IM3_IRL8   ] = { .cpu_used = 1, .name = "ASC1 Tx Buffer", .second = 0, .func = NULL, .cpu_mask = 1 },
    [INT_NUM_IM3_IRL9   ] = { .cpu_used = 1, .name = "ASC1 Rx", .second = 0, .func = NULL, .cpu_mask = 1 },
    [INT_NUM_IM3_IRL10  ] = { .cpu_used = 1, .name = "ASC1 Error", .second = 0, .func = NULL, .cpu_mask = 1 },
    [INT_NUM_IM3_IRL11  ] = { .cpu_used = 1, .name = "ASC1 Autobaud start", .second = 0, .func = NULL, .cpu_mask = 1 },
    [INT_NUM_IM3_IRL12  ] = { .cpu_used = 1, .name = "ASC1 Autobaud detect", .second = 0, .func = NULL, .cpu_mask = 1 },
    [INT_NUM_IM3_IRL13  ] = { .cpu_used = 1, .name = "ASC1 Software flow control", .second = 0, .func = NULL, .cpu_mask = 1 },
    [INT_NUM_IM3_IRL14  ] = { .cpu_used = 0, .name = "PCMLINK", .second = 0, .func = NULL, .cpu_mask = 0 },
    [INT_NUM_IM3_IRL15  ] = { .cpu_used = 1, .name = "Over voltage", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM3_IRL16  ] = { .cpu_used = 1, .name = "PCIe L3 ind", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM3_IRL17  ] = { .cpu_used = 1, .name = "GPHY1", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM3_IRL18  ] = { .cpu_used = 1, .name = "GPHY0", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM3_IRL19  ] = { .cpu_used = 0, .name = "", .second = 0, .func = NULL, .cpu_mask = 0 },
    [INT_NUM_IM3_IRL20  ] = { .cpu_used = 0, .name = "", .second = 0, .func = NULL, .cpu_mask = 0 },
    [INT_NUM_IM3_IRL21  ] = { .cpu_used = 1, .name = "USIF Rx", .second = 1, .func = NULL, .cpu_mask = 1 },
    [INT_NUM_IM3_IRL22  ] = { .cpu_used = 1, .name = "Timer Counter 1A", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM3_IRL23  ] = { .cpu_used = 1, .name = "Timer Counter 1B", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM3_IRL24  ] = { .cpu_used = 1, .name = "Timer Counter 2A", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM3_IRL25  ] = { .cpu_used = 1, .name = "Timer Counter 2B", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM3_IRL26  ] = { .cpu_used = 1, .name = "Timer Counter 3A", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM3_IRL27  ] = { .cpu_used = 1, .name = "Timer Counter 3B", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM3_IRL28  ] = { .cpu_used = 1, .name = "Memory Controller", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM3_IRL29  ] = { .cpu_used = 1, .name = "MPS Semaphore", .second = 1, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM3_IRL30  ] = { .cpu_used = 1, .name = "MPS Global", .second = 1, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM3_IRL31  ] = { .cpu_used = 1, .name = "EIU 1", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM4_IRL0   ] = { .cpu_used = 1, .name = "DMA Channel 20", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM4_IRL1   ] = { .cpu_used = 1, .name = "DMA Channel 21", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM4_IRL2   ] = { .cpu_used = 1, .name = "DMA Channel 22", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM4_IRL3   ] = { .cpu_used = 1, .name = "DMA Channel 23", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM4_IRL4   ] = { .cpu_used = 1, .name = "DMA Channel 24", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM4_IRL5   ] = { .cpu_used = 1, .name = "DMA Channel 25", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM4_IRL6   ] = { .cpu_used = 1, .name = "DMA Channel 26", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM4_IRL7   ] = { .cpu_used = 1, .name = "DMA Channel 27", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM4_IRL8   ] = { .cpu_used = 1, .name = "PCIe A", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM4_IRL9   ] = { .cpu_used = 1, .name = "PCIe B", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM4_IRL10  ] = { .cpu_used = 1, .name = "PCIe C", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM4_IRL11  ] = { .cpu_used = 1, .name = "PCIe D", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM4_IRL12  ] = { .cpu_used = 0, .name = "", .second = 0, .func = NULL, .cpu_mask = 0 },
    [INT_NUM_IM4_IRL13  ] = { .cpu_used = 0, .name = "", .second = 0, .func = NULL, .cpu_mask = 0 },
    [INT_NUM_IM4_IRL14  ] = { .cpu_used = 1, .name = "MPS Status 0", .second = 0, .func = NULL, .cpu_mask = 1 },
    [INT_NUM_IM4_IRL15  ] = { .cpu_used = 1, .name = "MPS Status 1", .second = 0, .func = NULL, .cpu_mask = 1 },
    [INT_NUM_IM4_IRL16  ] = { .cpu_used = 1, .name = "MPS Status 2", .second = 0, .func = NULL, .cpu_mask = 1 },
    [INT_NUM_IM4_IRL17  ] = { .cpu_used = 1, .name = "MPS Status 3", .second = 0, .func = NULL, .cpu_mask = 1 },
    [INT_NUM_IM4_IRL18  ] = { .cpu_used = 1, .name = "MPS Status 4", .second = 0, .func = NULL, .cpu_mask = 1 },
    [INT_NUM_IM4_IRL19  ] = { .cpu_used = 1, .name = "MPS Status 5", .second = 0, .func = NULL, .cpu_mask = 1 },
    [INT_NUM_IM4_IRL20  ] = { .cpu_used = 1, .name = "MPS Status 6", .second = 0, .func = NULL, .cpu_mask = 1 },
    [INT_NUM_IM4_IRL21  ] = { .cpu_used = 1, .name = "MPS Semaphore", .second = 0, .func = NULL, .cpu_mask = 1 },
    [INT_NUM_IM4_IRL22  ] = { .cpu_used = 1, .name = "MPS Global", .second = 0, .func = NULL, .cpu_mask = 1 },
    [INT_NUM_IM4_IRL23  ] = { .cpu_used = 1, .name = "Crossbar Error", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM4_IRL24  ] = { .cpu_used = 1, .name = "WDT Access Error", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM4_IRL25  ] = { .cpu_used = 1, .name = "PCIe E", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM4_IRL26  ] = { .cpu_used = 1, .name = "PCIe F", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM4_IRL27  ] = { .cpu_used = 1, .name = "MSI_IR A", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM4_IRL28  ] = { .cpu_used = 1, .name = "MSI_IR B", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM4_IRL29  ] = { .cpu_used = 1, .name = "MSI_IR C", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM4_IRL30  ] = { .cpu_used = 1, .name = "EIU 0", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_IM4_IRL31  ] = { .cpu_used = 1, .name = "VPE Performance", .second = 0, .func = NULL, .cpu_mask = 3 },
    [INT_NUM_SI_EIU_IR0 ] = { .cpu_used = 0, .name = "", .second = 0, .func = NULL, .cpu_mask = 0 },
    [INT_NUM_SI_EIU_IR1 ] = { .cpu_used = 0, .name = "", .second = 0, .func = NULL, .cpu_mask = 0 },
    [INT_NUM_SI_EIU_IR2 ] = { .cpu_used = 0, .name = "", .second = 0, .func = NULL, .cpu_mask = 0 },
    [INT_NUM_SI_EIU_IR3 ] = { .cpu_used = 0, .name = "", .second = 0, .func = NULL, .cpu_mask = 0 },
    [INT_NUM_SI_EIU_IR4 ] = { .cpu_used = 0, .name = "", .second = 0, .func = NULL, .cpu_mask = 0 },
    [INT_NUM_SI_EIU_IR5 ] = { .cpu_used = 0, .name = "", .second = 0, .func = NULL, .cpu_mask = 0 },
    [INT_NUM_SI_EIU_IR6 ] = { .cpu_used = 0, .name = "", .second = 0, .func = NULL, .cpu_mask = 0 },
    [INT_NUM_SI_EIU_IR7 ] = { .cpu_used = 0, .name = "", .second = 0, .func = NULL, .cpu_mask = 0 },
    [INT_NUM_SI_EIU_IR8 ] = { .cpu_used = 0, .name = "", .second = 0, .func = NULL, .cpu_mask = 0 },
    [INT_NUM_SI_EIU_IR9 ] = { .cpu_used = 0, .name = "", .second = 0, .func = NULL, .cpu_mask = 0 },
    [INT_NUM_SI_EIU_IR10] = { .cpu_used = 0, .name = "", .second = 0, .func = NULL, .cpu_mask = 0 },
    [INT_NUM_SI_EIU_IR11] = { .cpu_used = 0, .name = "", .second = 0, .func = NULL, .cpu_mask = 0 },
    [INT_NUM_SI_EIU_IR12] = { .cpu_used = 0, .name = "", .second = 0, .func = NULL, .cpu_mask = 0 },
    [INT_NUM_SI_EIU_IR13] = { .cpu_used = 0, .name = "", .second = 0, .func = NULL, .cpu_mask = 0 },
    [INT_NUM_SI_EIU_IR14] = { .cpu_used = 0, .name = "", .second = 0, .func = NULL, .cpu_mask = 0 },
    [INT_NUM_SI_EIU_IR15] = { .cpu_used = 0, .name = "", .second = 0, .func = NULL, .cpu_mask = 0 },
    [MIPS_CPU_TIMER_IRQ]  = { .cpu_used = 0, .name = "", .second = 0, .func = NULL, .cpu_mask = 0 },
    #ifdef CONFIG_SMP
        [MIPSCPU_INT_BASE]    = { .cpu_used = 0, .name = "", .second = 0, .func = NULL, .cpu_mask = 0 },
        [MIPSCPU_INT_BASE+1]  = { .cpu_used = 0, .name = "", .second = 0, .func = NULL, .cpu_mask = 0 }
    #endif /*--- #ifdef CONFIG_SMP ---*/
};

#endif /*--- #if defined(CONFIG_VR9) ---*/

#endif /*--- #ifndef VR9_INTERRUPT_TABLE__H ---*/
