/*
 *
 * i2c-avalanche.h 
 * Description:
 * Defines of the Avalanche IIC adapter data, etc.
 *
 * Copyright (C) 2008 Texas Instruments Incorporated - http://www.ti.com/ 
 * 
 * 
 *  Redistribution and use in source and binary forms, with or without 
 *  modification, are permitted provided that the following conditions 
 *  are met:
 *
 *    Redistributions of source code must retain the above copyright 
 *    notice, this list of conditions and the following disclaimer.
 *
 *    Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the 
 *    documentation and/or other materials provided with the   
 *    distribution.
 *
 *    Neither the name of Texas Instruments Incorporated nor the names of
 *    its contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
 *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 *  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
 *  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
 *  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 *  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 *  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
 *  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
*/

#ifndef I2C_ADAP_AVALANCHE_H
#define I2C_ADAP_AVALANCHE_H

#include <linux/i2c.h>
#include <asm/arch/generic/pal.h>

#define I2C_HW_AVALANCHE_ID             160
#define AVALANCHE_I2C_MIN_CLOCK         1000
#define AVALANCHE_I2C_MAX_CLOCK         400000

#define AVALANCHE_I2C_ERROR            -1

/* This struct contains the hw-dependent values of TI  IIC  */

struct iic_avalanche {
    unsigned long iic_base;
    int iic_irq;
    int iic_own;
	int polling_mode;
	int clock;
	int spike_filter;
	wait_queue_head_t iic_wait;
    int transfer_complete;
    unsigned int status;
	struct mutex avalanche_i2c_lock; 
};

#endif /* I2C_ADAP_AVALANCHE_H */
