/******************************************************************************
 * FILE NAME    : avm_printk.h                                                *
 * COMPANY      : AVM                                                         *
 * AUTHOR       : Heiko Blobner                                               *
 * DESCRIPTION  : Macros die jeder schon mindestens 10mal selbst implemen-    *
 *                tiert hat um auf die Console Texte auszugeben.              *
 *                                                                            *
 *****************************************************************************/

#define AVM_PRINTK_DBG

#define AVM_PRINTK_MSG(...)                                                                       printk(KERN_ERR __VA_ARGS__);     printk(KERN_ERR "\n");
#define AVM_PRINTK_DBG_ERROR(...)      printk(KERN_ERR "E[%s:%u]: ", __FUNCTION__, __LINE__);     printk(KERN_ERR __VA_ARGS__);     printk(KERN_ERR "\n");
#ifdef AVM_PRINTK_DBG
    #define AVM_PRINTK_DBG_WARN(...)   printk(KERN_WARNING "W[%s:%u]: ", __FUNCTION__, __LINE__); printk(KERN_WARNING __VA_ARGS__); printk(KERN_WARNING "\n");
    #define AVM_PRINTK_DBG_INFO(...)   printk(KERN_INFO "I[%s:%u]: ", __FUNCTION__, __LINE__);    printk(KERN_INFO __VA_ARGS__);    printk(KERN_INFO "\n");
#else /*--- #ifdef AVM_PRINTK_DBG ---*/
    #define AVM_PRINTK_DBG_WARN(...)   ;
    #define AVM_PRINTK_DBG_INFO(...)   ;
#endif /*--- #else ---*/ /*--- #ifdef AVM_PRINTK_DBG ---*/

