// ===========================================================================
//
// Copyright (C) 2002 Analog Devices Inc. All rights reserved
//
// The information and source code contained herein is the exclusive property
// of Analog Devices and may not be disclosed, examined or reproduced in whole
// or in part without the explicit written authorization from Analog Devices.
//
// ===========================================================================

// ===========================================================================
//
// File name    : $RCSfile: apconf.h
// Author       : $Author: sreeni
// Version      : $Revision:
// Description  : Modules configuration to build AP binaries
// ===========================================================================

#ifndef _APCONF_H_
#define _APCONF_H_

#include <sysconf.h>
#define   BRIDGE                1

#define   STATISTICS            1
#define   PORT_MONITORING       0
#define   WLAN_ETH_8023         1
#define   POLICY_BASED_VLAN     1

#define UBR_PLUS_FEATURE    	1

#if IS_VX180
#define IPCQOS	                0
#else
#define IPCQOS		        0
#endif

#if IS_VX180
#define PACKET_TAGGING 		0
#else
#define PACKET_TAGGING 		0
#endif
#define FASTPATH_FOR_FRAGMENTS  0

#if IS_VX180
#define   AP_FRAGMENTATION      1
#define   VENDOR_TAG            1
#define   IPV6                  1
#else
#define   AP_FRAGMENTATION      0
#define   VENDOR_TAG            0
#define   IPV6                  1
#define   ETH_NO_CLASSIFICATION	1
#define   PERI_INQ2_ADDR	0x191A0610
#endif

#if VENDOR_TAG
#define   MARVELL             0
#define   REALTEK             1

#if MARVELL && REALTEK
  Only one type of switch can be enabled.
#endif
#endif

#if IPV6
    #define   IPV4_INTO_IPV6        1
#endif

#define   BM_SPECIAL_STATS      1

#if IS_VX180
#define VDSL_PMEM_SHORT		        0
#define AP2AP_PPPOERELAY_FASTPATH       1
#else
#define VDSL_PMEM_SHORT		        0
#if ETH_NO_CLASSIFICATION
#define AP2AP_PPPOERELAY_FASTPATH       1
#else
#define AP2AP_PPPOERELAY_FASTPATH       0
#endif
#endif


#if !(IS_VX180)
#if IPV4_INTO_IPV6 && VENDOR_TAG
 Flow entry address calculation is not correct for this combination
#endif

#if IPV6 &&  WLAN_ETH_8023
#endif

#if POLICY_BASED_VLAN && VENDOR_TAG
 Cannot coexist .pmem and .dmem is in shortage for both options to be enabled.
#endif
#endif

#endif /* _APCONF_H_ */
