/* Copyright (C) 2006 Ikanos Communications
 * See IKANOS_PROP_LICENSE.txt for license information. */

// ===========================================================================
//
// File name    : $RCSfile: apprehdr.h,v $
// Description  : This describes the pre-header that exists at the start
//                of each data buffer.
// ===========================================================================
#ifndef _APPREHDR_H_
#define _APPREHDR_H_

#include <netpro/apconf.h>

#define AP_PRE_LEAD_UNUSED_LEN      128     
#define AP_PRE_TRAIL_UNUSED_LEN     128    
typedef struct
{
    void        *pEgress;       
    void        *pFlowID;      
} apEgressPort_t;

typedef struct apPreHeader_s
{
    struct apPreHeader_s        *pNext;
    unsigned short      flags1;
#define AP_FLAG1_IS_ETH_BIT     0       
#define AP_FLAG1_IS_802_BIT     1       
#define AP_FLAG1_IS_VLAN_BIT    2       
#define AP_FLAG1_IS_IP_BIT      3       
#define AP_FLAG1_IP_VER_4_BIT   8       
#define AP_FLAG1_IP_VER_6_BIT   9       
#define AP_FLAG1_TTL_ZERO_BIT   4       
#define AP_FLAG1_IP_FRAG_BIT    10      
#define AP_FLAG1_IP_CSUM_BIT    11      
#define AP_DECAPSULATED_PACKET_BIT      12      
#define AP_FLAG1_IS_POLICY_VLAN_BIT     13   
#define AP_FLAG1_IS_TCP_UDP_BIT 5       
#define AP_FLAG1_IS_IPSEC_BIT   6       
#define AP_FLAG1_IS_IPSEC_DECRYPTED_BIT   7 
#define AP_FLAG1_BRIDGE_ROUTE_BIT  14   
#define AP_FLAG1_CLASSIFIED_BIT 15      
   unsigned short      flags2;
#define AP_FLAG2_SRC_MAC_BIT    0       
#define AP_FLAG2_DST_MAC_BIT    1       
#define AP_FLAG2_SRC_MOD_BIT    2       
#define AP_FLAG2_DST_MOD_BIT    3       
#define AP_FLAG2_BRIDGE_PKT_BIT 4       
#define AP_MULTICAST_PKT_BIT    5       
#define AP_MCAST_SMAC_MOD_BIT   6       
#define AP_EGGRESS_PPPOE_BIT    7        
#define AP_FLAG2_BAD_HOP_LIMIT_BIT    8       
#define AP_FLAG2_ZERO_FLOW_LABEL_BIT  9       
#if defined(VENDOR_TAG) && (VENDOR_TAG)
#define AP_VENDOR_TXTAG_BIT           11      
#define AP_VENDOR_RXTAG_BIT           12      
#endif
#if defined(PORT_MONITORING) && (PORT_MONITORING)
#define AP_CLASSIFY_AFTER_TX_BIT     10      
#endif
#define AP_HOST_INDICATION_BIT  13      
#define AP_TX_STATUS_BIT        14      
#define AP_TX_DONE_BIT          15      
#define HOST_PKT_PROCESSED_BIT          AP_TX_DONE_BIT
    unsigned short      hash;
    unsigned short      start;          
    unsigned short      end;            
    unsigned short      l2HeaderLen;
    unsigned short      totalLength;

    void                *pRxPortId;
#define AP_MAX_EGRESS_PORTS     4
    apEgressPort_t      egressList[AP_MAX_EGRESS_PORTS];
    unsigned short      specInfoElement;
    unsigned short      ingressVLAN;
#define  NO_MATCHED_ENTRY_FOUND         0
    unsigned int        matchedEntryAddr;
} apPreHeader_t;

#endif /* _APPREHDR_H_ */
